;******************************************************  
; ALFAPIC.ASM versione 1.1a di Pierluigi Felletti IW4AA  
;******************************************************  
;
;
; MANIPOLATORE  CW  di  tipo  giambico  ( IAMBIC ) ,  
; con  memoria  punto - linea .  
;
;
;
; Questa  la versione VELOCE di ALFAPIC con tono a 1024 Hz .  
;
;
;
; >>>>>>>>>>>>>>>>>>>>  IMPORTANTE  <<<<<<<<<<<<<<<<<<<<<  
;
; Il programma ALFAPIC.ASM  stato scritto da IW4AA Pierluigi Felletti 
; nel linguaggio assembly del PIC 16F84(A) della Microchip .  
; Pu essere utilizzato liberamente dai radioamatori PER USO PRIVATO .  
; Trattasi quindi di un programma FREEWARE ( di libero uso ) .  
;

; Questo programma pu essere scaricato via INTERNET dal sito 
; http://www.edizionicec.it  ( bottone :  AREA DOWNLOAD ) ,  
; file  ALFAPIC.ZIP  .    ( rivista  " radiokit elettronica "  )  
;
; Nessuno pu appropriarsi di questo programma per scopi commerciali 
; o di lucro .  Pur consentendone l'utilizzo privato ,  
; IW4AA Pierluigi Felletti  e resta il proprietario di questo software .  
;
; Questo programma viene fornito cos com' !  Non viene fornita 
; nessuna garanzia implicita e/o esplicita di corretto funzionamento .  
; Pertanto l'Autore non  responsabile per eventuali inconvenienti 
; derivanti dall'uso di questo programma .  Sono graditi consigli ,  
; suggerimenti e segnalazioni di errori .  Chi trova qualcosa che 
; non va ,   pregato di farmelo sapere al pi presto .  Grazie .  
;
; Per  modifiche  e / o  richieste  inviare i messaggi a  
; IW4AA  Pierluigi  Felletti :  
;
; E-mail  iw4aa.pf@libero.it  <--------------------
;
;
;
; Oppure scrivere al seguente indirizzo :  
;
;                 Felletti Pierluigi 
;                 via Dantona n. 13 
;                 48100 RAVENNA - Italia ( Italy ) 
;
; allegando ,  se lo si ritiene necessario ,  dischetto gi formattato e 
; busta pre-affrancata e pre-indirizzata .  Non telefonare .  GRAZIE .  
;

;
;
; COMMENTI   ; COMMENTI   ; COMMENTI   ; COMMENTI   ; COMMENTI :  
;
; "ALFAPIC" utilizza un 
; OSCILLATORE ESTERNO AL QUARZO  
; -----------------------------  
;
; quarzo  XTAL  da  4,194304 MHz = 4.194.304 Hz  ( quarzo "binario" )  
;
; DIVISIONI EFFETTUATE :  
;
; 4.194.304 / 4   = 1.048.576 Hz  hardware del PIC  
; 1.048.576 / 256 = 4.096 Hz      PRESCALER del PIC  
; 4096 / 256      = 16 Hz         TIMER0  ( registro TMR0 )  
; 16 / 16         = 1 Hz          eventuale contatore per i secondi 
;
; bit-7  bit-6  bit-5  bit-4  bit-3 bit-2  bit-1  bit-0 -  registro TMR0  
;    16     32     64    128    256   512   1024   2048 -  frequenza in Hz  
;
;
;
; -----------------------------------------------------------------------  
;
; Linee di 
; ingresso (I)  
; e di uscita (O)  
;
; LINEE di I/O   NOME dato alla linea / FUNZIONE / USO  
;   porta A      -------------------------------------  
; ------------   
;
; RA0   IN       MANPJ = manipolatore Puro o Giambico ( Iambic ) ?  
;
; RA1   IN       ONOFF = Scelta del tipo di uscita ( su RA2 ) :  
;                        uscita di BF oppure uscita di tipo ON-OFF .  
;                        ( 512 o 1.024 Hz )            ( 0  /  +5 Vcc )  
;
;                USCITA PRINCIPALE DEL PROGRAMMA :  
; RA2   OUT      BF1 = uscita di BF , cio nota CW ( punti e linee ) ,  
;                oppure  uscita ON-OFF per TX  e/o  cicalini o buzzer .  
;
; RA3   OUT      LEDR = LED rosso per carattere CW errato e altri usi .  
;                In generale indica  STOP momentaneo o temporaneo per 
;                altre eventuali operazioni  oppure  ERRORE .  
;
; RA4   IN       ASCEE = ASColto dei caratteri copiati nella EEPROM-dati 
;                in modalit MANUALE  oppure  ASColto dei caratteri 
;                CW immessi e memorizzati in modalit MEMORIA ( AUTO ) .  
;
; -----------------------------------------------------------------------  
;
; Linee di 
; ingresso (I)  
; e di uscita (O)  
;
; LINEE di I/O   NOME dato alla linea / FUNZIONE / USO  
;  porta B       -------------------------------------  
; ------------   
;
; RB0   IN       SAVEBUF = per salvare i BUFfers-xy nella EEPROM-dati .  
;
; RB1   IN       PESO = PESATURA PUNTO-LINEA :  1 a 3  oppure  1 a 4 .  
;
; RB2   IN       MEMOMAN = modo MEMORIA  o  modo MANuale .  
;
; RB3   IN       AZZBUFF = azzeramento dei BUFfers-xy ,  cio della  
;                          memoria volatile in modo MEMORIA  
;                                  oppure  
;                          azzeramento della  EEPROM-dati del PIC  
;                          ( memoria permanente ) in modo MANuale .  
;
;                PADDLE ( tasto per Morse ) gestito sotto interrupt :  
; RB4   IN       PUNTO = punto dal tasto di tipo paddle ( interrupt ) ;  
; RB5   IN       LINEA = linea dal tasto di tipo paddle ( interrupt ) .  
;
; RB6   IN       FCAR = fine CARattere ( interrupt ) .  
;
; RB7   IN       FWORD = fine PAROLA ( interrupt ) .  
;
; *********************************************************************  
;

        PROCESSOR       16F84
        RADIX           DEC
        INCLUDE         "P16F84.INC"

; Messaggio di avvertimento numero 302 di MPASM :  
; " Message(302) :  Register in operand not in bank 0. 
;   Ensure that bank bits are correct. "  
; Per sopprimere questo messaggio togliere il punto e virgola  
; nella riga ERRORLEVEL .  In questo modo nel file ALFAPIC.ERR ,  
; output di MPASM ,  non vi saranno pi questi avvertimenti .  

;       ERRORLEVEL      -302

;
;
; Setup of PIC configuration flags .  
;
; XT oscillator ,  Disable Watch Dog Timer 
; Enable Power Up Timer ,  Disable Code Protect 
;
        __CONFIG        3FF1H
;
;
; per PORT-B :  
SAVEBUF   EQU     0
PESO      EQU     1
MEMOMAN   EQU     2
AZZBUFF   EQU     3
PUNTO     EQU     4
LINEA     EQU     5
FCAR      EQU     6
FWORD     EQU     7
;
; per PORT-A :  
MANPJ     EQU     0
ONOFF     EQU     1
BF1       EQU     2
LEDR      EQU     3
ASCEE     EQU     4
;

        ORG     0CH

;
; Registri per il salvataggio dell'accumulatore W e del registro STATUS .  
; Vengono usati nella ISR di ALFAPIC .  
; Registro --- numero --- <1> .  
W_TEMP      RES 1
; Registro --- numero --- <2> .  
STATUS_TEMP RES 1
;
;
;
; DUR come DURata .  
; Registro --- numero --- <3> .  
DUR     RES     1
; Registro --- numero --- <4> .  
RIM     RES     1
;
;
;
; Registro usato come interruttore o switch per gli ERRORI .  
; Registro --- numero --- <5> .  
SWCERR  RES     1
;
;
;
; Registro o switch per indicare ( eventuali ) linee / punti residue/i .  
;
; SWCULT = 11111111B = ascolto o riproduzione da "ICAR" oppure 
;                      direttamente dalle palette del tasto ( paddle ) .  
;                      Quindi o sono all'inizio ( accensione ) oppure 
;                      in una situazione di ripartenza .  
;
; SWCULT = 0         = ascolto o riproduzione dai BUFfers-xy .  
;
; Registro --- numero --- <6> .  
SWCULT  RES     1
;
;
;
; Registro WORK1 per la durata della LINEA  e  
; registro WORK2 per la durata del PUNTO .  
; Registro --- numero --- <7> .  
WORK1   RES     1
; Registro --- numero --- <8> .  
WORK2   RES     1
;
;
;
; Puntatore usato in fase di ascolto o riproduzione  ( per LOOP-2 ) .  
; PNT = PuNtaTore ,  RIP = RIProduzione .  
; Registro --- numero --- <9> .  
PNTRIP  RES     1
;
;
; Buffers di memoria per salvare i caratteri CW "ICAR" immessi 
; e accettati da ALFAPIC .  
; ( MEMORIA VOLATILE per i caratteri CW immessi e accettati .  )  
; Registro --- numero --- <10> .  
BUF1    RES     1
; Registro --- numero --- <11> .  
BUF2    RES     1
; Registro --- numero --- <12> .  
BUF3    RES     1
; Registro --- numero --- <13> .  
BUF4    RES     1
; Registro --- numero --- <14> .  
BUF5    RES     1
; Registro --- numero --- <15> .  
BUF6    RES     1
; Registro --- numero --- <16> .  
BUF7    RES     1
; Registro --- numero --- <17> .  
BUF8    RES     1
; Registro --- numero --- <18> .  
BUF9    RES     1
; Registro --- numero --- <19> .  
BUF10   RES     1
;
;
;
;             BUFB                       BUFA        
; 7  8  6  5  4  3  2  1  0     7  6  5  4  3  2  1  0    
;
;                  10  9  8     7  6  5  4  3  2  1  <-----  BUFFERS  
;
; bit 1 = registro BUFfer da far ascoltare ,  
; bit 0 = registro BUFfer gi ascoltato .  
;
; Registri di abilitazione alla riproduzione .  
; Leggere le routine  QUALEBUFFER:  e  SALVA_ICAR:  .    
;
; Registro --- numero --- <20> .  
BUFA    RES     1
; Registro --- numero --- <21> .  
BUFB    RES     1
;
;
;
; Registro "CAR" per salvare i punti e le linee di ogni 
; carattere del MESSAGGIO letto nella EEPROM-dati .  
; Registro --- numero --- <22> .  
CAR           RES     1
;
; Registro "ICAR" usato nella routine dell'interrupt punto-linea .  
; In "ICAR" vengono memorizzati i punti e le linee del carattere CW 
; in corso ,  come dire in costruzione .  
; "ICAR" = Interrupt-CAR .  
; Registro --- numero --- <23> .  
ICAR          RES     1
;
; Registro --- numero --- <24> .  
SCAR          RES     1
; Registro --- numero --- <25> .  
SALVA         RES     1
;
;
;
; Contatore usato per i caratteri CW accettati  ( puntatore per LOOP-1 ) .  
; In CTRCW  ALFAPIC conta i caratteri CW completi ACCETTATI .  
;                                                 ---------  
; In caso di errore il carattere CW immesso non viene accettato .  
; CTR = ConTatoRe ,  CW = per i caratteri CW accettati .  
; Registro --- numero --- <26> .  
CTRCW         RES     1
;
;
;
; Registro NLP = Numero Linee e/o Punti di ogni carattere del MESSAGGIO ,  
; ossia numero dei bit da prendere in considerazione per ogni "CAR" .  
; Registro --- numero --- <27> .  
NLP           RES     1
;
; Registro INLP usato nella routine dell'interrupt punto-linea .  
; INLP = Interrupt-NLP ,  cio NLP usato nella ISR ,  LOOP-1 .  
; Registro --- numero --- <28> .  
INLP          RES     1
;
; Registro per il Salvataggio di INLP o di NLP .  
; Registro --- numero --- <29> .  
SNLP          RES     1
;
; Contatore per i Punti riprodotti  e/o  per le Linee riprodotte ,  
; cio gi fatti/e ascoltare per un singolo carattere CW .  
; CTR = ConTatoRe ,  PL = Punti e Linee .  
; Registro --- numero --- <30> .  
CTRPL         RES     1
;
;
;
; Indirizzo fisico - reale che mi indica il primo byte libero 
; nella EEPROM-dati .  Questo registro viene usato anche 
; nella routine  ULTIMI_TITA  per altri scopi .  
; Registro --- numero --- <31> .  
fisicoT       RES     1

; Registro usato nella routine SALVA_MESSAGGIO .  
; Questo registro viene usato anche per altri scopi .  
; Per esempio dopo la label o etichetta  Fine_ih:  nella ISR .  
; Registro --- numero --- <32> .  
TOTC          RES     1
;
;
;
;           ******  
; Registro  GENREG  per uso generale ,  per vari scopi .  
;           ******  
; Significato e utilizzo dei suoi bits :  
;
;       bit 7   PAUSA lunga di fine PAROLA ;  
;               ( fine PAROLA = fine CAR + pausa lunga )  
;
;       bit 6   1 = fine conteggio dei registri WT1 e WT2 ,  
;                   ossia COMPLETAMENTO del carattere "ICAR" ;  
;               1 = CAR_COMPLETO ,  per/secondo WT2 ( quando WT2 = 0 ) ,  
;               0 = CAR-COMPLETO ,  causa interrupt sulla linea  
;                   RB6 ( fine CARattere )  o  RB7 ( fine PAROLA )  oppure  
;                   anche quando INLP = 6 ;  
;
;       bit 5   1 = "ICAR" errato  ,   0 = "ICAR" corretto ;  
;               ( segnalazione del LOOP-1 per il LOOP-2 )  
;
;       bit 4   1 = no SALVA_MESSAGGIO ( nella EEPROM-dati ) ,  
;               0 = s SALVA_MESSAGGIO ( nella EEPROM-dati ) ;  
;
;       bit 3   1 = salva "ICAR" e INLP in SCAR e SNLP ;  
;               ( abilitazione alla copia nella prima parte del LOOP-2 )  
;
;       bit 2   1 = modo / modalit  MANUALE ;  
;
;       bit 1   1 = modo / modalit  MEMORIA ;  
;
;       bit 0   non usato .  
;
;
; Registro --- numero --- <33> .  
GENREG        RES     1
;
;
;
; Ciclo anti-rimbalzo .  Routine  RITARDO:  .   
; Registro anti-rimbalzo e anche registro per salvataggi temporanei .  
; Registro --- numero --- <34> .  
ANTIRS        RES     1
;
;
;
; Registri usati nella  routine   SETTAWT:   e nelle 
; istruzioni che precedono la label  ML_VAI:  .   
; Conteggio della pausa per le istruzioni di CARattere completato .  
; Registro --- numero --- <35> .  
WT1           RES     1
; Conteggio della PAUSA che indica fine CARattere ,  cio CAR COMPLETO !  
; Registro --- numero --- <36> .  
WT2           RES     1
;
;
;
; Reset Vector = Program Start Point at CPU reset .  
        ORG     00H
        goto    Start
;
        ORG     04H


;**********************************************************************  
; Interrupt handler = Gestione degli interrupts .  
; ISR = Interrupt Service Routine .  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  
;**********************************************************************  


; PRIMA OPERAZIONE della ISR !!!  
; Salvataggio dell'accumulatore W e del registro STATUS .  
        movwf   W_TEMP          ; salva W in W_TEMP
        swapf   STATUS,W
        movwf   STATUS_TEMP     ; salva STATUS in STATUS_TEMP


; QUALE EVENTO HA PROVOCATO L'INTERRUPT ?  
; Check the interrupt event .  
; Interrupt sulle linee RB4-RB5-RB6-RB7 ?  
        btfsc   INTCON,RBIF
        goto    Int_RBIF

; ALFAPIC non gestisce l'interrupt di fine scrittura della EEPROM-dati .  
; ALFAPIC non gestisce l'interrupt sulla linea RB0 .  
; ALFAPIC non gestisce l'interrupt da overflow del registro TMR0 .  
        goto    End_ih


;
; -----------------------------------------------------------------------  
; FINE della Gestione degli Interrupts con istruzioni anti-rimbalzo .  
;      ISTRUZIONI ANTI-RIMBALZO !  ISTRUZIONI ANTI-RIMBALZO !  
;
; La pressione su un pulsante provoca ovviamente la sua chiusura ma ,  
; in realt ,  se potessimo vedere alla moviola ( o al rallentatore 
; come in un filmato ad alta velocit ) questa semplice operazione 
; potremmo notare  a) come i contatti rimbalzino alcune volte prima 
; di chiudersi in modo stabile  oppure  b) delle micro scintille .  
; Oppure  anche  entrambe  le  cose ,  ossia  a)  +  b) .  
; Questi rimbalzi possono durare anche qualche decimo di secondo nel 
; caso di contatti molto grandi ( per esempio teleruttori ) ,  qualche 
; millesimo di secondo ( millisecondi ) nel caso dei pulsanti di segnale 
; per elettronica .  Con un quarzo da 4 MHz il tempo di esecuzione delle 
; istruzioni in un PIC 16F84  di circa 1 microsecondo ,  cio un 
; milionesimo di secondo !  Quindi ,  rimbalzi o micro-scintille 
; che durano qualche millisecondo possono essere facilmente  "visti/e"  
; o  "interpretati/e"  dal PIC come  2 ( due ) o pi punti  oppure  
; 2 ( due ) o pi linee ,  in definitiva come ripetuti interrupts .  
; Per risolvere questo problema bisogna ASPETTARE che la commutazione 
; meccanica delle palette del tasto ( paddle ) si stabilizzi .  Ossia 
; che il contatto resti chiuso in modo stabile per un certo tempo !  
; Poich il pulsante o tasto ideale ( aperto / chiuso ,  come dire 0 / 1 ) 
; non esiste ,  bisogna gestire via software questo problema molto 
; semplicemente aspettando un "certo" tempo una volta che  scattato 
; l'interrupt punto-linea .  Vedere la routine  RITARDO:  .  
;
; Oppure testare per "enne" volte che il contatto sia chiuso .  
; Anche in questo caso occorre trovare ,  mediante le prove ,  quale 
; sia il valore pi idoneo per questo numero "enne" .  
; Da tasto a tasto infatti potrebbero esserci delle differenze .  
;
; Leggere a questo proposito anche la Nota D) della documentazione ,  
; files  ALFAPIC.TXT  in formato ASCII ( edit del DOS )  oppure  
; ALFAPIC.DOC  in formato WIN Word .  Questi files sono tutti 
; nel file compresso  ALFAPIC.ZIP  .  
;
;
; Questa  la versione VELOCE di ALFAPIC con tono a 1024 Hz .  
;
;
; COMMENTO .  
; Con il tasto usato da IW4AA ,  il valore 31 decimale  
; ( + 2 condensatori da 33.000 pF )  VA BENE .  
; Con tasti dotati di miglior meccanica si pu scendere ,  
; per esempio ,  anche a 15 decimale .  Bisogna provare .  
; Se si dispone di un tasto dotato di ottimi contatti ,  
; per abbreviare la durata totale dell'interrupt PUNTO-LINEA 
; usare dopo la label  Fine_ih:   la seguente istruzione :  
;
;        movlw   31  
;        movwf   TOTC  
; oppure  
;        movlw   15  
;        movwf   TOTC  .    
;
; -----------------------------------------------------------------------  
;

Fine_ih:
        movlw   31
        movwf   TOTC
FiCICLO:
; Routine di ritardo software .  
        call    RITARDO
        decfsz  TOTC,F
        goto    FiCICLO



;*******************************************  
; FINE  della  Gestione  degli  interrupts .  
;*******************************************  

End_ih:

;*******************************************************************  
; Aspetto il rilascio del contatto punto o linea prima di riattivare  
; l'interrupt sulle linee RB4-RB5-RB6-RB7 .  
; Aspetto cio di ritornare ,  da 0 Vcc = contatto chiuso ,  
; a +5 Vcc = contatto aperto .  
; In questo modo per la durata dell'interrupt in pratica  
; uguale alla durata della chiusura del contatto punto-linea ,  
; o del pulsante di fine-CARattere o di fine-PAROLA .  
;*******************************************************************  
;
; Interrupt sulla linea RB4 = PUNTO .  Contatto rilasciato ?  
        btfss   PORTB,PUNTO
        goto    End_ih
; Interrupt sulla linea RB5 = LINEA .  Contatto rilasciato ?  
        btfss   PORTB,LINEA
        goto    End_ih
; Interrupt sulla linea RB6 = FINE CARATTERE .  Contatto rilasciato ?  
        btfss   PORTB,FCAR
        goto    End_ih
; Interrupt sulla linea RB7 = FINE PAROLA .  Contatto rilasciato ?  
        btfss   PORTB,FWORD
        goto    End_ih


; *****************************  
; ULTIME ISTRUZIONI DELLA ISR .  
; *****************************  

; Reset the RBIF flag to re-enable the RB4-RB5-RB6-RB7 interrupts .  
        bcf     INTCON,RBIF

; ULTIMA OPERAZIONE della ISR !!!  
; Ripristino dell'accumulatore W e del registro STATUS .  
        swapf   STATUS_TEMP,W   
        movwf   STATUS          ; ripristino di STATUS
        swapf   W_TEMP,F
        swapf   W_TEMP,W        ; ripristino di W

; RITORNO AL PROGRAMMA PRINCIPALE - Go back to the main program .  
; ( Fine della Interrupt Service Routine )  
        retfie



;****************************************************************  
; Linee RB4-RB5-RB6-RB7 .  
; Routine degli interrupts per gestire :  
;               a) la memorizzazione dei PUNTI e delle LINEE ,  
;               b) la fine di un CARattere  e  
;               c) la fine  di una PAROLA ( WORD in inglese ) .  
;****************************************************************  

Int_RBIF:

; Con queste istruzioni l'interrupt sulle linee RB6-RB7  preso 
; in considerazione solo se una di queste due linee  a 0 Vcc .  
;
; -----------------------------------------------  
; Interrupt sulla linea RB6 ?  ( FINE CARATTERE )  
        btfss   PORTB,FCAR
        goto    fineCAR
; Interrupt sulla linea RB7 ?  ( FINE PAROLA )  
        btfss   PORTB,FWORD
        goto    finePAROLA
; -----------------------------------------------  


;
;
; IN FASE DI INTERRUPT :  
;
;       contatto         contatto         contatto  
;        chiuso           chiuso           chiuso  
;
; +5 Vcc          pausa            pausa            pausa    
; Ŀ       Ŀ       Ŀ           
;                                              
;                                              
;  0 Vcc - - -   - - -   - - -  > tempo  
;         LINEA            PUNTO            PUNTO  
;
;       routine di       routine di       routine di  
;       interrupt        interrupt        interrupt  
;      PUNTO-LINEA      PUNTO-LINEA      PUNTO-LINEA  
;
;
; IN FASE DI ASCOLTO :  
;
;          nota di  
;          BF a 512 Hz    pausa             pausa             pausa    
;        Ŀ       Ŀ       Ŀ    
;                                                      
;                                                      
; 0                                     > tempo  
;             LINEA     silenzio   PUNTO  silenzio   PUNTO    
;
; Notare che la LINEA di Bassa Frequenza  pi lunga della durata  
; della chiusura del contatto della paletta delle LINEE .  
;
; Anche il PUNTO di Bassa Frequenza pu essere pi lungo della durata 
; della chiusura del contatto della paletta dei PUNTI .  
;
; ASCII 196  ,  ASCII 179  ,  ASCII 191  ,  ASCII 192  ,  
; ASCII 217  ,  ASCII 218  .  
;
;


; Palette del tasto PADDLE in uso ?  
;
; Con queste istruzioni l'interrupt sulle linee RB4-RB5  preso 
; in considerazione solo se una di queste due linee  a 0 Vcc .  
;
; Interrupt sulla linea RB4 = PUNTO ?  ...........................  
        btfss   PORTB,PUNTO
        goto    MEM_PUNTO
; Interrupt sulla linea RB5 = LINEA ?  ---------------------------  
        btfss   PORTB,LINEA
        goto    MEM_LINEA

; ISTRUZIONE NECESSARIA  ( per sicurezza )  !    
        goto    End_ih


; Interrupt per il PUNTO :  memorizzo subito il PUNTO e poi vado 
; alla label  INC_INLP  ,   quindi esco dalla routine dell'interrupt .  
MEM_PUNTO:
; I vari bit 0 vengono inseriti da destra verso sinistra cio 
; dal bit meno significativo verso quello pi significativo .  
; La paletta del paddle ha dato un Punto ,  allora bit CARRY = 0 .  
        bcf     STATUS,C
        rlf     ICAR,F


; Incremento INLP = Numero Linee & Punti del carattere "ICAR" .  
INC_INLP:

; A )  
; Abilitazione del salvataggio di "ICAR" e di INLP .  
; < Bit-3 di GENREG ACCESO = 1 >  "comunica" alla prima parte del LOOP-2  
; che  stato immesso un Punto ,  oppure che  stata immessa una Linea .  
; Se questo bit  acceso ,  allora posso salvare "ICAR" e INLP 
; rispettivamente nei registri SCAR e SNLP ( nella prima parte del LOOP-2 ) 
; allo scopo di fare poi ascoltare linee e/o punti immessi .  
        bsf     GENREG,3

; B )  
; Imposto qui i valori iniziali dei registri WT1 e WT2 che verranno 
; poi decrementati nel Main_Loop .  In pratica ,  ogni volta che 
; immetto un Punto o una Linea ,  riparto con il conteggio  
; della pausa dai valori iniziali .  Anche quando completo un CARattere .  
;
        call    SETTAWT

; C )  
; ISTRUZIONE  FONDAMENTALE  DI  QUESTA  LABEL  INC_INLP:  !    
        incf    INLP,F

; D )  
; Nessun carattere del codice Morse  composto da oltre 6 punti-linee .  
; Se INLP = 6 ,  allora carattere "ICAR" completo .  
        movlw   6
        xorwf   INLP,W
        btfss   STATUS,Z
        goto    Fine_ih



; S ,  INLP = 6  ===>  CARATTERE "ICAR" COMPLETO !  

;
; CARATTERE "ICAR" COMPLETO anche quando il conteggio della pausa termina .  
; Vedere a questo riguardo la gestione dei registri WT1 e WT2 .  
; ( WTEMPO nella versione con oscillatore RC - versione non divulgata ) .  
; Oppure quando premo i pulsanti  RB7 = fine PAROLA  o  
;                                 RB6 = fine CARATTERE .  
;
;
; Quattro ( 4 ) eventi indicano fine CARattere o fine PAROLA :  
;
; 1) INLP = 6 ;  
; 2) pulsante RB6 ( fine CARattere ) ;  
; 3) pulsante RB7 ( fine PAROLA = fine CAR + pausa lunga ) ;  
; 4) azzeramento di WT2 .  
;


; ================================================  
; Carattere  "I-CAR"  completato  !    
; ---------------------------------  
; Il LED rosso di STOP viene sempre acceso per 
; indicare fine CARattere oppure fine PAROLA .  
; Fine PAROLA = fine CARattere + pausa lunga .  
; ================================================  
CAR_COMPLETO:

; Accendo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
        bcf     PORTA,LEDR

; Imposto qui i valori iniziali dei registri WT1 e WT2 che verranno 
; poi decrementati nel Main_Loop .  In pratica ,  riparto con il 
; conteggio della pausa ogni volta che immetto un Punto o una Linea  
; oppure  anche quando completo un CARattere "ICAR" .  
;
        call    SETTAWT


; ---------------------------------------------------------------  
; Nella routine  < cont_CAR >  si usa il registro "CAR" ,  ma qui  
; nella routine dell'interrupt si usa il registro "ICAR" .  
; ---------------------------------------------------------------  
; Controllo la correttezza formale del carattere CW immesso .  

; Salvo il registro "CAR" :  non  usato nella routine dell'interrupt .  
        movf    CAR,W
        movwf   ANTIRS
; Copio "ICAR" in CAR .  
        movf    ICAR,W
        movwf   CAR
;
        call    cont_CAR
; Ripristino il registro "CAR" originale .  
        movf    ANTIRS,W
        movwf   CAR

; ----------------------------------------  
; SWCERR ERRATO ?  
        movlw   00000000B
        xorwf   SWCERR,W
        btfsc   STATUS,Z
        goto    si_CAR


; ///////////////////////////   
; ERRORE :  "ICAR"  ERRATO  !   
;
; Poich il carattere "ICAR"  errato non memorizzo nulla .  
; NON SI INCREMENTA CTRCW ( il registro per il conteggio dei caratteri ) 
; E quindi NEMMENO SALVO "ICAR" nei BUFfers-xy .  
;
; Attesa o pausa prima dei 7 punti che segnalano carattere errato .  
        call    LONGWAIT
;
; < 7 PUNTI  TI-TI-TI-TI-TI-TI-TI > per segnalare il carattere errato !  
;             1  2  3  4  5  6  7   
        call    SETTE_BIP
; "ICAR" errato !  
; < Bit-5 di GENREG ACCESO = 1 >  "comunica" alla prima parte del LOOP-2  
; che il  carattere CW "ICAR"  in essere / in corso  errato !  
        bsf     GENREG,5
        goto    CC_Fine


;
; /////////////////////////   
; OK :  "ICAR"  CORRETTO  !   
si_CAR:

; GENREG,4 = 1  NO SALVA_MESSAGGIO nella EEPROM-dati del PIC ;  
; GENREG,4 = 0  s ,  SALVA_MESSAGGIO nella EEPROM-dati del PIC .  
; Ogni volta che memorizzo un nuovo CARattere CW ( cio un "ICAR" )  
; azzero il bit numero 4 di GENREG in modo da consentire il  
; salvataggio dei buffers-xy nella EEPROM-dati del PIC .  
        bcf     GENREG,4

; Azzero il bit-5 di GENREG = "ICAR" corretto .  
; < Bit-5 di GENREG SPENTO = 0 >  "comunica" alla prima parte del LOOP-2  
; che il  carattere CW "ICAR"  in essere / in corso  corretto !  
        bcf     GENREG,5

; Incremento il contatore dei caratteri CW immessi e ACCETTATI .  
; ISTRUZIONE  FONDAMENTALE  PER  IL  LOOP-1  .    
        incf    CTRCW,F
        movlw   11
; CTRCW = 11 ?  
        xorwf   CTRCW,W
        btfss   STATUS,Z
        goto    NO_undici

; CTRCW = 11  ===>  allora riporto il contatore dei caratteri  
; CW immessi a uno-1 .  Anche il puntatore dei registri BUFFERS-xy  
; ( registro PNTRIP ) viene gestito in questo modo .    
        movlw   1
        movwf   CTRCW

;
NO_undici:
; Pausa lunga ?  Me lo dice il bit numero 7 di GENREG .  
        btfsc   GENREG,7
        bsf     ICAR,7
; -----------------------------------------------------  
; Salvo/copio "ICAR" in un qualche registro BUFfer-xy .  
; Cio in uno dei dieci ( 10 ) registri BUF-xy .  
; -----------------------------------------------------  
        call    SALVA_ICAR
;

;
CC_Fine:
; Azzero "ICAR" e INLP .  
        call    resetICAR
;
; Azzero il bit-7 di GENREG ;  mi indica l'eventuale PAUSA LUNGA .  
        bcf     GENREG,7

; Spengo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
        bsf     PORTA,LEDR

;
; Se fine conteggio di WT1 e WT2 ,  allora debbo tornare a ML_VAI !  
        btfss   GENREG,6
        goto    End_ih

; Azzero il bit-6 di GENREG .  
        bcf     GENREG,6
        goto    ML_VAI



; Interrupt per la LINEA :  memorizzo subito la LINEA e poi vado 
; alla label  INC_INLP  ,   quindi esco dalla routine dell'interrupt .  
MEM_LINEA:
; I vari bit 1 vengono inseriti da destra verso sinistra cio 
; dal bit meno significativo verso quello pi significativo .  
; La paletta del paddle ha dato una Linea ,  allora bit CARRY = 1 .  
        bsf     STATUS,C
        rlf     ICAR,F
        goto    INC_INLP


;*********************************************************************  
; RB6 :  interrupt per gestire la fine di un CARattere .  
;*********************************************************************  
fineCAR:
; Se INLP = 0  ===>  esco subito da questo interrupt .  
        movlw   0
        xorwf   INLP,W
        btfss   STATUS,Z
; INLP diverso da 0  ===>  salvo ICAR in un registro BUF-xy .  
        goto    CAR_COMPLETO
; INLP = 0  ===>  esco subito da questo interrupt !  
        goto    End_ih


;*********************************************************************  
; RB7 :  interrupt per gestire la fine di una PAROLA .  
;*********************************************************************  
finePAROLA:
; Devo impostare a 1 il bit numero 7 ( ottavo bit ) di ICAR .  
; Questo  infatti il segnale o bit di fine PAROLA .  

; Se INLP = 0  ===>  esco subito da questo interrupt .  
        movlw   0
        xorwf   INLP,W
        btfsc   STATUS,Z
; INLP = 0 !  ===>  esco subito da questo interrupt !  
        goto    End_ih
;
        bsf     GENREG,7
        goto    CAR_COMPLETO




;********************************************************************** 
;    Main Flow    Main Flow    Main Flow    Main Flow    Main Flow   
;********************************************************************** 

Start:

;
; Commuta sul secondo banco per accedere ai registri TRISA e TRISB .  
; ( Bank 1 ) .  
        bsf     STATUS,RP0

; Definizione delle linee di I/O ( 0=Uscita ,  1=Ingresso ) .  
;
; Definizione della porta A .  -------------------------------------------  
; RA0   IN=1     MANPJ = manipolatore Puro o Iambic ?  
;                USCITA PRINCIPALE DEL PROGRAMMA :  
; RA1   IN=1     ONOFF = Scelta del tipo di uscita ( su RA2 ) :  
;                        out BF oppure out ON-OFF .  
; RA2   OUT=0    BF1 = uscita di BF :  nota CW ( punti e linee )  
;                oppure uscita ON-OFF per TX  e/o  cicalini o buzzer .  
; RA3   OUT=0    LEDR = LED rosso per carattere CW errato e altri usi .  
;                In generale indica STOP temporaneo/momentaneo per altre 
;                eventuali operazioni oppure ERRORE .  
; RA4   IN=1     ASCEE = ASColto dei caratteri copiati nella EEPROM-dati o 
;                        ASColto della memoria volatile .  
;
;                             RA4     RA3     RA2     RA1     RA0  
; * bit 7 * bit 6 * bit 5 * bit 4 * bit 3 * bit 2 * bit 1 * bit 0 * = TRISA 
;
        movlw   00010011B
        movwf   TRISA & 7FH
;
; Definizione della porta B .  -------------------------------------------  
; RB0   IN       SAVEBUF = per salvare i BUFfers-xy nella EEPROM-dati .  
; RB1   IN       PESO = PESATURA PUNTO-LINEA :  1 a 3  oppure  1 a 4 .  
; RB2   IN       MEMOMAN = modo MEMORIA  o  modo MANuale .  
; RB3   IN       AZZBUFF = azzeramento dei BUFfers-xy ,  cio della 
;                          memoria volatile  oppure  della EEPROM-dati .  
;
;                PADDLE ( tasto per Morse ) gestito sotto interrupt :  
; RB4   IN       PUNTO = punto dal tasto di tipo paddle ( interrupt ) .  
; RB5   IN       LINEA = linea dal tasto di tipo paddle ( interrupt ) .  
; RB6   IN       FCAR = fine CARattere ( interrupt ) .  
; RB7   IN       FWORD = fine PAROLA ( interrupt ) .  
;
;     RB7     RB6     RB5     RB4     RB3     RB2     RB1     RB0  
; * bit 7 * bit 6 * bit 5 * bit 4 * bit 3 * bit 2 * bit 1 * bit 0 * = TRISB 
        movlw   11111111B
        movwf   TRISB & 7FH
;
;
; Bit 7 = RBPU = 0 .  
; PS2  PS1  PS0  divisore  
;  0    0    0      2  
;  0    0    1      4  
;  0    1    0      8  
;  0    1    1     16  
;  1    0    0     32  
;  1    0    1     64  
;  1    1    0    128   
;  1    1    1    256
;
;
; Assegna il PRESCALER a TMR0 e lo configura a 1:256 .  
        movlw   00000111B
        movwf   OPTION_REG & 7FH
;
; Commuta sul primo banco dei registri ( Bank 0 ) .  
        bcf     STATUS,RP0
; Spengo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
        bsf     PORTA,LEDR
;
; Setto l'USCITA collegata alla porta RA2 ( piedino 1 del PIC ) .  
;         ------  
; Per SOURCE si intende una corrente che esce da un pin del PIC e 
; va verso massa passando attraverso un carico ,  per esempio un AP .  
; In SOURCE il PIC pu pilotare direttamente un carico di 
; 20 mA a 5 Vcc = 100 mW .  
;
; Per SINK una corrente che circola da un positivo dentro a un pin 
; del PIC quando questo  a 0 Vcc .  
; In SINK il PIC pu pilotare direttamente un carico di 
; 25 mA a 5 Vcc = 125 mW .  
; 
; Come si vede dal circuito attuatore l'uscita  di tipo SINK .  
;                                                        ----  
; Per il circuito attuatore leggere l'articolo :  
;       " ALFAPIC manipolatore CW con memoria "  
; di Pierluigi Felletti IW4AA  e  Marino Cenci IW4BIF  
; pubblicato sulla rivista tecnica  " radiokit elettronica "   
; n.  10  OTTOBRE  2004   alle pagine  70 ,  71 ,  72  e  73 .    
;
; Spengo l'altoparlante AP o il cicalino .  
;
        bsf     PORTA,BF1



; ---------------------------------------------------  
; Azzeramento / inizializzazione di alcuni registri .  
; ---------------------------------------------------  
;
Azzeramenti:
; Disabilito TUTTI gli interrupts !  
        bcf     INTCON,GIE
; Accendo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
        bcf     PORTA,LEDR
; Azzero i registri BUFfers-xy .  
        call    azzeraBUF
;
        clrf    DUR
        clrf    RIM
        clrf    GENREG
; CTRPL = 0 ,  SWCULT = 0 .  
        call    azzeraPL
; CAR=0 ,  NLP=0 .  
        call    azzeraCAR
; ICAR=0 ,  INLP=0 .  
        call    resetICAR
;
; Spengo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
        bsf     PORTA,LEDR
; Azzero il TIMER del PIC .  
        clrf    TMR0



; ================================================================  
; ==== LOOP ==== LOOP ==== LOOP ==== LOOP ==== LOOP ==== LOOP ====  
; ================================================================  

Main_Loop:


; ****************************************************   
; Modo MANUALE ( puro o giambico )  o   modo MEMORIA ?   
; ****************************************************   

; ****************************************************   
; Modo MEMORIA  o  modo MANUALE ( puro o giambico )  ?   
; ****************************************************   

        btfsc   PORTB,MEMOMAN
        goto    INmanuale


; Modo / modalit MEMORIA .  

; Controllo il bit-2 del modo MANUALE .  
        btfsc   GENREG,2
        goto    Azzeramenti
; Bit-1 = 1  significa  modo MEMORIA !  
        bsf     GENREG,1

; Pesatura fra Punto e Linea  ( 1-3 oppure 1-4 ) .  
        call    PESATURA

; Linea RB3 ( piedino 9 ) = AZZERAMENTO Buffers-xy ?  
        btfss   PORTB,AZZBUFF
        goto    Azzeramenti

; Gestione della EEPROM-dati del PIC :  
; SALVA_MESSAGGIO per copiare nella EEPROM-dati i registri BUFfers-xy .  
; Il pulsante SAVEBUF ( linea RB0 ) attiva la routine per memorizzare 
; nella EEPROM-dati del PIC tutti i buffers BUFFERS-xy .  
; Copia / salvataggio dei caratteri dalla memoria volatile del PIC  
; ( registri BUFfers-xy ) nella memoria permanente ( EEPROM-dati ) .  
        btfss   PORTB,SAVEBUF
        call    SALVA_MESSAGGIO


;
; CARATTERE "ICAR" COMPLETO anche quando il conteggio della pausa termina .  
; Oppure quando premo i pulsanti  RB7 = fine PAROLA  o  
;                                 RB6 = fine CARATTERE .  
; La durata della pausa dipende dal valore di WT2 .  
; Leggere a questo proposito la routine < SETTAWT: > .  
;

;
; Se INLP = 0  ===>  proseguo .  
        movlw   0
        xorwf   INLP,W
        btfsc   STATUS,Z
        goto    ML_VAI

; Decremento il registro WT1 .  
        decfsz  WT1,F
        goto    ML_VAI

; Imposto di nuovo WT1 al valore iniziale .  
        clrf    WT1
; Decremento il registro WT2 .  
        decfsz  WT2,F
        goto    ML_VAI

; Terminato il conteggio ( WT2 = 0 = pausa terminata ) ,  ALFAPIC  
; considera il CARattere "ICAR"  completo e quindi esegue le istruzioni 
; dell'etichetta o label  CAR_COMPLETO:  !    
;
; Disabilito TUTTI gli interrupts !  
        bcf     INTCON,GIE
; Imposto a 1 il bit numero 6 del registro GENREG .  
        bsf     GENREG,6
        goto    CAR_COMPLETO

;
ML_VAI:

; Modo/modalit MEMORIA .  
;
; MEMORIA PUNTO-LINEA abilitata ,  devo attivare gli interrupts .  
; Abilito gli interrupts delle linee RB4-RB7 ,  
; cio RB4 ,  RB5 ,  RB6  ed  RB7 .  
; Registro INTCON :  
; bit 7  GIE  = Global Interrupt Enable 
; bit 6  EEIE = EEprom Interrupt Enable 
; bit 5  T0IE = TMR0 Interrupt Enable 
; bit 4  INTE = INTErrupt RB0 
; bit 3  RBIE = RB linee da 4 a 7 Interrupt Enable 
; bit 2  T0IF = Interrupt Flag per TMR0 
; bit 1  INTF = INTerrupt Flag per RB0 
; bit 0  RBIF = Interrupt Flag per RB4-RB7 
; 
        movlw   10001000B
        movwf   INTCON
; Queste 2 istruzioni equivalgono a :  
;       BSF     INTCON,GIE   ( bit 7 )  
;       bcf     INTCON,EEIE  ( bit 6 )  
;       bcf     INTCON,T0IE  ( bit 5 )  
;       bcf     INTCON,INTE  ( bit 4 )  
;       BSF     INTCON,RBIE  ( bit 3 )  
;       bcf     INTCON,T0IF  ( bit 2 )  
;       bcf     INTCON,INTF  ( bit 1 )  
;       bcf     INTCON,RBIF  ( bit 0 )  

;
; LOOP per memorizzare PUNTI e/o LINEE        LOOP per la riproduzione 
;      gestito tramite interrupts                  dei caratteri CW dai 
;                                                  BUFfers-xy 
;      ------>--------                             ------>-------- 
;      I             I                             I             I 
;      I             I                             I             I 
;      I    CTRCW    I                             I    PNTRIP   I 
;      I             I                             I             I 
;      I             I                             I             I 
;      ------<--------                             ------<-------- 
;
;                          CTRCW  =  PNTRIP ?  
; 
;  SI' ===>  Faccio ascoltare i Punti e/o le Linee leggendo i bit 
;            ( 0 = Punto ,  1 = Linea ) dal registro "ICAR"  ( INLP )  
;            oppure direttamente dalle stesse palette del tasto / paddle .  
;            Ovviamente all'inizio ,  cio all'accensione del PIC ,  
;            CTRCW = PNTRIP = 0  !   
;
;  NO  ===>  Devo riprodurre ,  cio far ascoltare ,  i caratteri CW 
;            dai  registri  BUFfers-xy  gi  utilizzati .  
;


; Attivo o non attivo l'ascolto dei Punti e/o delle Linee  
; immessi/immesse sotto interrupt ( linee RB4-RB5 ) ?  
; Cio in modo o modalit MEMORIA ?  
        btfsc   PORTA,ASCEE
        goto    Main_Loop



; Operazione effettuata :  W = CTRCW .  
        movf    CTRCW,W

; Operazione effettuata :  PNTRIP = CTRCW  ?   

; Confronto fra i puntatori dei due ( 2 ) loop !  
; LOOP-1 ( interrupts ) e LOOP-2 ( ascolto / riproduzione ) .  
; CTRCW per LOOP-1  e  PNTRIP per LOOP-2 .  
        xorwf   PNTRIP,W
        btfss   STATUS,Z
        goto    DAI_BUFFERS


; S ,  < CTRCW = PNTRIP >  !    


;
; SWCULT = registro o switch che indica la parte di LOOP-2 in esecuzione ,  
;          quindi anche eventuali linee/punti residue/i .  
;                       ---------  
;
; SWCULT = 11111111B = ascolto o riproduzione da "ICAR" oppure 
;                      direttamente dalle palette del tasto ( paddle ) .  
;                      Quindi o sono all'inizio ( accensione ) oppure 
;                      in una situazione di ripartenza .  Sono quindi 
;                      nella PRIMA parte del LOOP-2 .  
;
; SWCULT = 0         = ascolto o riproduzione dai BUFFERS-xy ,  quindi 
;                      nessun residuo ;  vengo dalla SECONDA parte del 
;                      LOOP-2 ,  ossia riproduzione dei BUFFERS-xy .  
;
;

        movlw   11111111B
        movwf   SWCULT


; Se "ICAR" errato ,  quindi bit-5 di GENREG acceso ,  devo 
; gestire questo caso e ,  per esempio ,  azzerare il contatore CTRPL .  
        btfss   GENREG,5
        goto    INLP_zero
; Disabilito per un attimo TUTTI gli interrupts !  
        bcf     INTCON,GIE
        goto    ICARerrato


INLP_zero:

; INLP = 0 ?  
        movlw   0
; Operazione effettuata :  INLP = 0  ?   
        xorwf   INLP,W
        btfss   STATUS,Z
        goto    NON_ZERO

; S ,  INLP = 0 !  
;
; PUNTO ?  
        btfsc   PORTB,PUNTO
        goto    I_LINEA
; Punto ......................................................  
; un solo punto (.) + pausa .  
        movf    WORK2,W
        movwf   DUR
        call    LP1
        call    P_WAIT1
; Incremento il contatore CTRPL per il conteggio dei bit Punto 
; gi ascoltati / riprodotti .  
        incf    CTRPL,F
        goto    Main_Loop

; LINEA ?  
;
I_LINEA:
        btfsc   PORTB,LINEA
        goto    Main_Loop
; Linea ------------------------------------------------------  
; una sola linea (-) + pausa .  
        movf    WORK1,W
        movwf   DUR
        call    LP1
        call    P_WAIT1
; Incremento il contatore CTRPL per il conteggio dei bit Linea 
; gi ascoltati / riprodotti .  
        incf    CTRPL,F
        goto    Main_Loop



NON_ZERO:

; Se bit-3 di GENREG = 1 allora salvo "ICAR" e INLP .  
; Bit-3 di GENREG = 1  ===>  salvataggio abilitato .  
; Bit-3 di GENREG = 0  ===>  salvataggio disabilitato .  
; < Bit-3 di GENREG ACCESO = 1 >  "comunica" alla prima parte del LOOP-2  
; che  stato immesso un Punto ,  oppure che  stata immessa una Linea .  
; Se questo bit  acceso ,  allora posso salvare "ICAR" e INLP 
; per l'ascolto ,  per la riproduzione .  In pratica effettuo il 
; salvataggio di "ICAR" e di INLP  SE E SOLO SE  c' stata l'immissione 
; di almeno un Punto o di almeno una Linea .  
        btfss   GENREG,3
        goto    Main_Loop

; Per un attimo debbo disabilitare gli interrupts RB4-RB7 per 
; non correre il rischio di avere SCAR ed SNLP disallineati .  

; Disabilito per un attimo TUTTI gli interrupts !  
        bcf     INTCON,GIE

; Se "ICAR" errato ,  quindi bit-5 di GENREG acceso ,  devo 
; gestire questo caso e ,  per esempio ,  azzerare il contatore CTRPL .  
        btfss   GENREG,5
        goto    NZ_salva



; ------------------------------------------------------    
;
; SI' ,  "ICAR"  ERRATO ( info fornita dal LOOP-1 )  !    
;
; Quando "ICAR"  errato ( vedere routine di interrupt )  
; la riproduzione del carattere CW pu essere troncata .  
;
; ------------------------------------------------------    

ICARerrato:
; Azzero il conteggio dei punti e/o delle linee .  
        call    azzeraPL
; Azzero il bit-5 di GENREG .  
        bcf     GENREG,5
; Disabilito il salvataggio di "ICAR" e di INLP .  
        bcf     GENREG,3
; Riabilito di nuovo TUTTI gli interrupts !  
        bsf     INTCON,GIE
; Vado a esaminare di nuovo CTRCW e PNTRIP !  
        goto    Main_Loop



;
NZ_salva:
; Salvo "ICAR" e INLP per la riproduzione dei punti e/o delle linee .  
;                            ------------  
; Salvataggio di "ICAR" .  
        movf    ICAR,W
        movwf   SCAR
; Salvataggio di INLP .  
        movf    INLP,W
        movwf   SNLP

; Poich ho appena effettuato il salvataggio di "ICAR" e di INLP ,  
; disabilito qui il salvataggio di "ICAR" e di INLP .  
        bcf     GENREG,3

; Riabilito TUTTI gli interrupts !  
        bsf     INTCON,GIE



; $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ ;  
;
; A questo punto posso riprodurre i punti e/o le linee che 
; ho in SCAR ( indicati da SNLP ) a meno che la differenza 
; tra SNLP e CTRPL non dia come risultato zero .  
; Il che vorrebbe dire che ho gi ascoltato i punti e le 
; linee presenti in SCAR .  
;
; $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ ;  
; 
; Operazione effettuata :  W = CTRPL .  
        movf    CTRPL,W
; Operazione effettuata :  SNLP = SNLP - CTRPL(W) .  
        subwf   SNLP,F
        btfss   STATUS,Z
        goto    NZaltro

; Z=1 se il risultato  uguale a zero .  
; Se la differenza  uguale a zero ,  ossia SNLP = 0 ,  ho gi 
; fatto ascoltare tutte le linee e/o tutti i punti presenti in "ICAR" !  
; Presenti in "ICAR" al momento della copia in SCAR .  
        goto    Main_Loop


; Se ( SNLP - CTRPL ) < 0 ,  cio la DIFFERENZA  NEGATIVA ,  
; allora si  verificato un caso particolare .  
; C=1 se il risultato  positivo o uguale a 0 ,  
; C=0 se il risultato  negativo .  
NZaltro:
        btfss   STATUS,C
        goto    NEGATIVA

; SNLP positivo ,  OK .  
; Ascolto o riproduzione dei PUNTI e/o delle LINEE !  
        call    ULTIMI_TITA
        goto    Main_Loop




; -----------------------------------------------------------   
;           E V E N T O    P A R T I C O L A R E    
; Potrebbe verificarsi in casi eccezionali o particolari .  
; Per esempio mentre il PIC sta eseguendo le istruzioni della 
; prima parte del LOOP-2  e  CTRCW e PNTRIP non hanno pi lo 
; stesso valore a causa di una rapida serie di interrupts .  
; -----------------------------------------------------------   
;
; LA DIFFERENZA  ( SNLP - CTRPL )  EST NEGATIVA !  

NEGATIVA:
; Disabilito TUTTI gli interrupts !!!   
        bcf     INTCON,GIE
; Accendo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
        bcf     PORTA,LEDR
; Doppia PAUSA LUNGA per segnalare questo caso particolare .  
        call    LONGWAIT
        call    LONGWAIT
; Spengo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
        bsf     PORTA,LEDR
; Vado a esaminare di nuovo CTRCW e PNTRIP !  
; Se sono diversi ,  verr esaminato SWCULT per vedere se ci sono 
; punti e/o linee ancora da far ascoltare  oppure  no .   
        goto    Main_Loop




; ***************************************************************  
; CTRCW diverso da PNTRIP !!!  Devo leggere i caratteri CW 
; dai registri BUFFERS-xy .  
; ***************************************************************  
DAI_BUFFERS:

; Ho finito di riprodurre il primo o precedente carattere ?  
; S ,  oppure c' ancora qualche punto o qualche linea da riprodurre ?  
; Cio ancora da far ascoltare ?  Me lo dice il registro SWCULT !  
;
; Registro o switch per indicare la parte del LOOP-2 in esecuzione ,  
; quindi anche per eventuali linee/punti residue/i .  
;
; SWCULT = 11111111B = ascolto-riproduzione da "ICAR" oppure 
;                      direttamente dalle palette del tasto ( paddle ) .  
;                      Quindi o sono all'inizio ( accensione ) oppure 
;                      in una situazione di ripartenza .  
;                      Vengo quindi dalla PRIMA parte del LOOP-2 .  
;
; SWCULT = 0         = ascolto-riproduzione dai BUFfers-xy ,  
;                      sono nella SECONDA parte del LOOP-2 .  
;

        movlw   0
; Operazione effettuata :  SWCULT = 0  ?   
        xorwf   SWCULT,W
        btfsc   STATUS,Z
        goto    RIP_BUFFER

; SWCULT = 11111111B ,  vedo se ci sono linee e/o punti residue/i da 
; riprodurre - cio da far ascoltare - per il carattere "ICAR" in corso .  

        call    PUNTABUF

; Se "CAR" = 0 non riproduco nessun carattere CW .  
        movlw   0
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    ULT_ISTR
;
        call    calcola_NLP
; Copio NLP in SNLP .  
        movf    NLP,W
        movwf   SNLP
; Copio "CAR" in SCAR .  
        movf    CAR,W
        movwf   SCAR
; Operazione effettuata :  W = CTRPL .  
        movf    CTRPL,W
; Operazione effettuata :  SNLP = SNLP - CTRPL(W) .              
        subwf   SNLP,F
        btfsc   STATUS,Z
        goto    ULT_ISTR
; Z=1 se il risultato  uguale a zero .  
; SNLP = 0 ,  ho gi fatto ascoltare TUTTI i punti e TUTTE le linee !  

OK_RIPR:
; Se ( SNLP - CTRPL ) < 0 ,  cio la DIFFERENZA  NEGATIVA ,  
; allora si  verificato un caso particolare .  
; C=1 se il risultato  positivo o uguale a 0 ,  
; C=0 se il risultato  negativo .  
        btfss   STATUS,C
        goto    NEGATIVA
; SNLP positivo ,  OK .  
        call    ULTIMI_TITA
;
ULT_ISTR:
        call    azzeraPL
        goto    Main_Loop


; -----------------------------------------------------------------  
; RIPRODUZIONE DEI CARATTERI CW ( PUNTI e/o LINEE ) dai BUFFER-xy .  
; -----------------------------------------------------------------  

RIP_BUFFER:

; Esamino ora BUFA e BUFB .  
        movlw   00000000B
        xorwf   BUFA,W
        btfss   STATUS,Z
        goto    testPUNT
        xorwf   BUFB,W
        btfss   STATUS,Z
        goto    testPUNT
;
        call    azzeraPL

; -------------------------------------  
; Ho gi riprodotto tutti i BUFers-xy !  
; -------------------------------------  

        goto    Main_Loop


;
; *****************************************************************  
; LOOP-2 ( parte seconda ) di ASCOLTO-RIPRODUZIONE dai BUFfers-xy .  
; Riproduzione di un carattere CW da un BUFfer-xy .  
; *****************************************************************  
;
; PNTRIP < CTRCW   oppure   PNTRIP > CTRCW  .    
;

testPUNT:

        call    PUNTABUF

; Se "CAR" = 0 non riproduco nessun carattere CW .  
        movlw   0
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    Main_Loop

; Prima devo salvare "CAR" per vedere in seguito se l'ottavo bit (bit n. 7) 
;  impostato a 1 .  In tal caso infatti devo fare o inserire una 
; PAUSA LUNGA dopo il carattere poich la parola  terminata .  
        movf    CAR,W
        movwf   SALVA
; Il carattere "CAR" potrebbe avere il bit n. 7 impostato .  Lo azzero .  
        bcf     CAR,7
; Ora estraggo dal registro/byte "CAR" tutte le info che sono riuscito 
; a registrarvi .  Devo impostare anche il registro NLP e 
; azzerare il bit di riempimento ( filler-bit ) .  
        call    calcola_NLP
; Ora dispongo di NLP .  Converto 
; il carattere "CAR" in punti e/o linee .  
        call    CW_CAR
; Dopo il carattere "CAR" vedo se  richiesta la PAUSA LUNGA .  
        btfsc   SALVA,7
        call    LONGWAIT
        call    azzeraPL
        goto    Main_Loop




; -----------------------------------------------------------------  
; M O D A L I T A '    M A N U A L E  :  PURA  o  GIAMBICA  .   
; -----------------------------------------------------------------  
INmanuale:  
; Disabilito TUTTI gli interrupts !  
        bcf     INTCON,GIE

; Controllo il bit-1 del modo MEMORIA .  
        btfsc   GENREG,1
        goto    Azzeramenti
; Bit-2 = 1  significa  modo MANUALE !  
        bsf     GENREG,2

;
; ******************************************  
; FUNZIONE OSCILLOFONO  FUNZIONE OSCILLOFONO  
; ******************************************  

        call    PESATURA

; Modo MANuale GIAMBICO ( Iambic )  o  MANuale Puro ?  
        btfsc   PORTA,MANPJ
        goto    puromanuale

;
; Sto usando le palette del paddle ?  Punto e/o linea ?  
;

; Modo s MANUALE ma GIAMBICO ( iambic ) .  
; Faccio ascoltare un PUNTO poi eventualmente una LINEA o viceversa .  
        btfsc   PORTB,PUNTO
        goto    UNALINEA
; punto ......................................................  
; un punto (.)  + pausa  .   
        movf    WORK2,W
        movwf   DUR
        call    LP1
        call    P_WAIT1

UNALINEA:
        btfsc   PORTB,LINEA
        goto    ASCOLTO_MESSAGGIO
; linea ------------------------------------------------------  
; una linea (-)  + pausa  .   
        movf    WORK1,W
        movwf   DUR
        call    LP1
        call    P_WAIT1
        goto    ASCOLTO_MESSAGGIO


; Modo MANUALE PURO .  
; Oscillofono manuale .  MANUALE  PURO .  MANUALE  PURO  .    
; Finch dura un punto nessuna linea e finch dura una linea nessun punto .  
;
; ******************************************  
; FUNZIONE OSCILLOFONO  FUNZIONE OSCILLOFONO  
; ******************************************  

puromanuale:

; PUNTO ?  
        btfsc   PORTB,PUNTO
        goto    PMLINEA
continua_PUNTO:
; punto .......................................................  
        call    NCW1
        btfss   PORTB,PUNTO
        goto    continua_PUNTO
        bsf     PORTA,BF1
        call    P_WAIT1

PMLINEA:
; LINEA ?  
        btfsc   PORTB,LINEA
        goto    ASCOLTO_MESSAGGIO
continua_LINEA:
; linea -------------------------------------------------------  
        call    NCW1
        btfss   PORTB,LINEA
        goto    continua_LINEA
        bsf     PORTA,BF1
        call    P_WAIT1


; ====================================================================== 
;
;   Gestione della EEPROM-dati ( memoria permanente ) del PIC :  
;
;                  ASCOLTO_EEPROM   per la riproduzione dei 
;                                   caratteri CW salvati nella EEPROM ;  
;
;                  azzeraEEPROM     per cancellare / azzerare tutto 
;                                   il contenuto della EEPROM-dati .  
;
; ====================================================================== 

ASCOLTO_MESSAGGIO:
; Ascolto del MESSAGGIO copiato / salvato nella EEPROM-dati ?  
; Lettura dei caratteri dalla EEPROM-dati del PIC .  
        btfss   PORTA,ASCEE
        call    ASCOLTO_EEPROM

; AZZERAMENTO / PULIZIA della EEPROM-dati del PIC ?   000000000000000000000 
; Questa funzione serve per azzerare tutta la EEPROM-dati del PIC .  
        btfss   PORTB,AZZBUFF
        call    azzeraEEPROM
;
        goto    Main_Loop





; *************************************************************************  
; * DA QUI INIZIANO TUTTE LE SUB-ROUTINES UTILIZZATE IN QUESTO PROGRAMMA  *  
; *************************************************************************  



;
; Emissione di una nota continua PUNTO o LINEA .  
; Routine solo per oscillofono in modalit MANUALE .  
; Il tono della nota non  esattamente uguale a quello che si ascolta in 
; modalit MEMORIA poich dopo ogni ciclo < bcf PORTA,BF1 - bsf PORTA,BF1 > 
; il programma controlla che la paletta sia ancora abbassata cio a massa .  
; Leggere la routine NCW1 e confrontarla con la routine LP1 .  
;
;
; quarzo XTAL = 4,194304 MHz = 4.194.304 Hz 
; 4.194.304 / 4   = 1.048.576 Hz  hardware del PIC 
; 1.048.576 / 256 = 4.096 Hz      PRESCALER del PIC 
; 4096 / 256      = 16 Hz         TIMER0 ( registro TMR0 ) 
; 16 / 16         = 1 Hz          eventuale contatore per i secondi 
;
; bit-7  bit-6  bit-5  bit-4  bit-3 bit-2  bit-1  bit-0 -  registro TMR0  
;    16     32     64    128    256   512   1024   2048 -  frequenza in Hz  
;
;
NCW1:
        btfss   TMR0,1
        goto    NCW1
        bcf     PORTA,BF1
NCW10:
        btfsc   TMR0,1
        goto    NCW10
; Uscita di BF a onda quadra per altoparlanti ?  
; Uscita di tipo ON/OFF per cicalini o buzzer e TX ?  
;
        btfss   PORTA,ONOFF
        return
; Uscita di BF a onda quadra per altoparlanti .  
        bsf     PORTA,BF1
        return




; --------------------------------------------------------------------  
; La routine SALVA_ICAR viene chiamata solo nella label CAR_COMPLETO .  
; --------------------------------------------------------------------  
;
SALVA_ICAR:
; Preparo opportunamente il carattere "ICAR" .  
; Effetto di questa routine :  
; Se "ICAR" = A = 00000001 ( INLP = 2 )  all'uscita  diventato 01111101 .  
; Se "ICAR" = K = 00000101 ( INLP = 3 )  all'uscita  rimasto   00000101 .  
; Nel primo caso il filler-bit ( bit numero 6 ossia il settimo bit ) 
; vale 1 mentre nel secondo vale 0 .  
        call    filler_bit

; Ora ,  in base al valore di CTRCW ,  memorizzo il carattere "ICAR" 
; nel corrispondente registro BUF-xy :  
; se CTRCW =  1  memorizzo "ICAR" nel registro BUF1  ;  
; se CTRCW =  2  memorizzo "ICAR" nel registro BUF2  ;  
; se CTRCW =  3  memorizzo "ICAR" nel registro BUF3  ;  
; se CTRCW =  4  memorizzo "ICAR" nel registro BUF4  ;  
; se CTRCW =  5  memorizzo "ICAR" nel registro BUF5  ;  
; se CTRCW =  6  memorizzo "ICAR" nel registro BUF6  ;  
; se CTRCW =  7  memorizzo "ICAR" nel registro BUF7  ;  
; se CTRCW =  8  memorizzo "ICAR" nel registro BUF8  ;  
; se CTRCW =  9  memorizzo "ICAR" nel registro BUF9  ;  
; se CTRCW = 10  memorizzo "ICAR" nel registro BUF10 .  
;
;
;             BUFB                       BUFA        
; 7  8  6  5  4  3  2  1  0     7  6  5  4  3  2  1  0    
;
;                  10  9  8     7  6  5  4  3  2  1  <-----  BUFFERS  
;
; bit 1 = registro BUFfer-xy da far ascoltare ,  
; bit 0 = registro BUFfer-xy gi ascoltato .  
;

; CTRCW = 1 ?  
        movlw   1
        xorwf   CTRCW,W
        btfss   STATUS,Z
        goto    A_BUF2
; CTRCW = 1 !  
        movf    ICAR,W
        movwf   BUF1
        bsf     BUFA,1
        return

A_BUF2:
; CTRCW = 2 ?  
        movlw   2
        xorwf   CTRCW,W
        btfss   STATUS,Z
        goto    A_BUF3
; CTRCW = 2 !  
        movf    ICAR,W
        movwf   BUF2
        bsf     BUFA,2
        return

A_BUF3:
; CTRCW = 3 ?  
        movlw   3
        xorwf   CTRCW,W
        btfss   STATUS,Z
        goto    A_BUF4
; CTRCW = 3 !  
        movf    ICAR,W
        movwf   BUF3
        bsf     BUFA,3
        return

A_BUF4:
; CTRCW = 4 ?  
        movlw   4
        xorwf   CTRCW,W
        btfss   STATUS,Z
        goto    A_BUF5
; CTRCW = 4 !  
        movf    ICAR,W
        movwf   BUF4
        bsf     BUFA,4
        return

A_BUF5:
; CTRCW = 5 ?  
        movlw   5
        xorwf   CTRCW,W
        btfss   STATUS,Z
        goto    A_BUF6
; CTRCW = 5 !  
        movf    ICAR,W
        movwf   BUF5
        bsf     BUFA,5
        return

A_BUF6:
; CTRCW = 6 ?  
        movlw   6
        xorwf   CTRCW,W
        btfss   STATUS,Z
        goto    A_BUF7
; CTRCW = 6 !  
        movf    ICAR,W
        movwf   BUF6
        bsf     BUFA,6
        return

A_BUF7:
; CTRCW = 7 ?  
        movlw   7
        xorwf   CTRCW,W
        btfss   STATUS,Z
        goto    A_BUF8
; CTRCW = 7 !  
        movf    ICAR,W
        movwf   BUF7
        bsf     BUFA,7
        return

A_BUF8:
; CTRCW = 8 ?  
        movlw   8
        xorwf   CTRCW,W
        btfss   STATUS,Z
        goto    A_BUF9
; CTRCW = 8 !  
        movf    ICAR,W
        movwf   BUF8
        bsf     BUFB,1
        return

A_BUF9:
; CTRCW = 9 ?  
        movlw   9
        xorwf   CTRCW,W
        btfss   STATUS,Z
        goto    A_BUF10
; CTRCW = 9 !  
        movf    ICAR,W
        movwf   BUF9
        bsf     BUFB,2
        return

A_BUF10:
; CTRCW = 10 !  
        movf    ICAR,W
        movwf   BUF10
        bsf     BUFB,3
        return




;
; RIPRODUZIONE dei PUNTI e/o delle LINEE NON ANCORA ASCOLTATI/E  
; dal registro SCAR .  
;
; A questo punto devo convertire i bit 0 di SCAR in un PUNTO e i 
; bit 1 di SCAR in una LINEA .  
;
ULTIMI_TITA:
        movf    SNLP,W         ; W = SNLP
        sublw   8              ; W = 8 - SNLP
        movwf   fisicoT
;
UTancora:
        bcf     STATUS,C
        rlf     SCAR,F
        decfsz  fisicoT,F
        goto    UTancora
; Ho spostato gli SNLP-bit di SCAR all'estrema sinistra del registro SCAR .  
; Ossia da bit ... fino a bit 7 ,  inserendo a destra tutti bit = 0 .  
        movf    SNLP,W         ; W = SNLP
        addlw   1              ; W = 1 + SNLP
        movwf   fisicoT

;
; Sposto ogni bit nel CARRY e poi esamino se  = 0 oppure = 1 .  
; Ciclo :  UTaltro:  .  

UTaltro:
        rlf     SCAR,F
        decfsz  fisicoT,F
        goto    UTCARRY
; Pausa finale .  
;
; Attesa o pausa tra i caratteri .  
; --------------------------------  
; Pausa finale ( 3 volte la durata di un punto ) .  
; 120 = 3 * 40 .  Tre (3) volte la durata del punto .  
;
        movlw   120
        call    BREVEWAIT
        return

;
UTCARRY:
        btfss   STATUS,C
        goto    UTpunto
; Una sola linea (-)  pi  pausa .  
        movf    WORK1,W
        movwf   DUR
        goto    UTcomune
;
UTpunto:
; Un solo punto (.)  pi  pausa .  
        movf    WORK2,W
        movwf   DUR
UTcomune:
        call    LP1
        call    P_WAIT1
; Incremento il contatore CTRPL per il conteggio dei bit Punto - Linea .  
        incf    CTRPL,F
        goto    UTaltro




;
PUNTABUF:
; Incremento il puntatore per la riproduzione PNTRIP !  
        incf    PNTRIP,F
        movlw   11
; PNTRIP = 11 ?  
        xorwf   PNTRIP,W
        btfss   STATUS,Z
        goto    PBnoundici
; PNTRIP = 11  ===>  perci lo riporto a 1 !  
        movlw   1
        movwf   PNTRIP
PBnoundici:
        call    QUALEBUFFER
        return




; --------------------------------------------------------------  
; Scelgo il BUFfer-xy che mi occorre per la riproduzione  oppure  
; per gli ultimi TI-TA .  
; --------------------------------------------------------------  
QUALEBUFFER:
        clrf    CAR

; PNTRIP = 1 ?  
        movlw   1
        xorwf   PNTRIP,W
        btfss   STATUS,Z
        goto    QBRIP2
; PNTRIP = 1 !  
        btfss   BUFA,1
        return
; Copia di BUF1 in CAR .  
        movf    BUF1,W
        movwf   CAR
        bcf     BUFA,1
        return

QBRIP2:
; PNTRIP = 2 ?  
        movlw   2
        xorwf   PNTRIP,W
        btfss   STATUS,Z
        goto    QBRIP3
; PNTRIP = 2 !  
        btfss   BUFA,2
        return
; Copia di BUF2 in CAR .  
        movf    BUF2,W
        movwf   CAR
        bcf     BUFA,2
        return

QBRIP3:
; PNTRIP = 3 ?  
        movlw   3
        xorwf   PNTRIP,W
        btfss   STATUS,Z
        goto    QBRIP4
; PNTRIP = 3 !  
        btfss   BUFA,3
        return
; Copia di BUF3 in CAR .  
        movf    BUF3,W
        movwf   CAR
        bcf     BUFA,3
        return

QBRIP4:
; PNTRIP = 4 ?  
        movlw   4
        xorwf   PNTRIP,W
        btfss   STATUS,Z
        goto    QBRIP5
; PNTRIP = 4 !  
        btfss   BUFA,4
        return
; Copia di BUF4 in CAR .  
        movf    BUF4,W
        movwf   CAR
        bcf     BUFA,4
        return

QBRIP5:
; PNTRIP = 5 ?  
        movlw   5
        xorwf   PNTRIP,W
        btfss   STATUS,Z
        goto    QBRIP6
; PNTRIP = 5 !  
        btfss   BUFA,5
        return
; Copia di BUF5 in CAR .  
        movf    BUF5,W
        movwf   CAR
        bcf     BUFA,5
        return

QBRIP6:
; PNTRIP = 6 ?  
        movlw   6
        xorwf   PNTRIP,W
        btfss   STATUS,Z
        goto    QBRIP7
; PNTRIP = 6 !  
        btfss   BUFA,6
        return
; Copia di BUF6 in CAR .  
        movf    BUF6,W
        movwf   CAR
        bcf     BUFA,6
        return

QBRIP7:
; PNTRIP = 7 ?  
        movlw   7
        xorwf   PNTRIP,W
        btfss   STATUS,Z
        goto    QBRIP8
; PNTRIP = 7 !  
        btfss   BUFA,7
        return
; Copia di BUF7 in CAR .  
        movf    BUF7,W
        movwf   CAR
        bcf     BUFA,7
        return

QBRIP8:
; PNTRIP = 8 ?  
        movlw   8
        xorwf   PNTRIP,W
        btfss   STATUS,Z
        goto    QBRIP9
; PNTRIP = 8 !  
        btfss   BUFB,1
        return
; Copia di BUF8 in CAR .  
        movf    BUF8,W
        movwf   CAR
        bcf     BUFB,1
        return

QBRIP9:
; PNTRIP = 9 ?  
        movlw   9
        xorwf   PNTRIP,W
        btfss   STATUS,Z
        goto    QBRIP10
; PNTRIP = 9 !  
        btfss   BUFB,2
        return
; Copia di BUF9 in CAR .  
        movf    BUF9,W
        movwf   CAR
        bcf     BUFB,2
        return

QBRIP10:
; Se sono arrivato qui ,  allora PNTRIP = 10  !    
; PNTRIP = 10 !  
        btfss   BUFB,3
        return
; Copia di BUF10 in CAR .  
        movf    BUF10,W
        movwf   CAR
        bcf     BUFB,3
        return




;
; Attesa o pausa lunga tra le parole ( per esempio codice Q ) .  
; -------------------------------------------------------------  
; 240 = 6 * 40 .  Sei (6) volte la durata del punto .  
;
LONGWAIT:
        movlw   240
BREVEWAIT:
        movwf   DUR
        call    PW1
        return




; --------------------------------------------------------------------  
; Poich la lettura della EEPROM-dati  veloce ,  in fase di ASCOLTO 
; leggo direttamente i singoli caratteri CW dalla stessa EEPROM-dati .  
; Il byte numero zero della EEPROM va escluso dalla riproduzione !  
; Viene infatti usato da ALFAPIC nella routine  SALVA_MESSAGGIO  
; per un altro scopo :  indirizzo dell'ultimo byte occupato nella 
; EEPROM-dati del PIC in fase di memorizzazione .  
;
;     MESSAGGIO :  
;   0 1 -----------------------> 63   = 63 byte utilizzati .  
;               "CAR"  
; Parto dal byte numero 1 fino al byte numero 63 .  
; --------------------------------------------------------------------  

;
ASCOLTO_EEPROM:
; Bank 0 .  
        bcf     STATUS,RP0
; Accendo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
; LED rosso acceso = STOP per altre eventuali operazioni !  
        bcf     PORTA,LEDR
        clrf    fisicoT

; Incremento il registro  < fisicoT > = byte o indirizzo successivo .  
AEincr:
        incf    fisicoT,F
; fisicoT = 64 ?  
        movlw   64
        xorwf   fisicoT,W
        btfss   STATUS,Z
        goto    AElettura

; Quando fisicoT = 64 la lettura della EEPROM-dati  terminata .  
; Spengo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
; USCITA DALLA ROUTINE  ASCOLTO_EEPROM .  
        bsf     PORTA,LEDR
        return

; Lettura del carattere "CAR" dalla EEPROM-dati .  
; In EEADR l'indirizzo di memoria della EEPROM-dati che vogliamo leggere .  
AElettura:
        movf    fisicoT,W
        call    Leggi_EEPROM
        movwf   CAR

; Il Byte ( "CAR" ) letto dalla EEPROM-dati  = 0  ?  
; Se "CAR" = 0 allora Z = 1 .  
        movlw   0
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    AEincr

; Prima devo salvare "CAR" per vedere in seguito se l'ottavo bit (bit n. 7) 
;  impostato a 1 .  In tal caso infatti devo fare o inserire una 
; PAUSA LUNGA dopo il carattere poich la parola  terminata .  
        movf    CAR,W
        movwf   SALVA
; Il carattere "CAR" potrebbe avere il bit n. 7 impostato ,  perci 
; azzero il bit numero 7 .  
        bcf     CAR,7

; Ora estraggo dal byte CAR tutte le info che sono riuscito a registrarvi .  
; Devo impostare anche il registro NLP e azzerare i bits di riempimento .  
        call    calcola_NLP

; Controllo la correttezza del valore di NLP .
; Valori corretti di NLP :  da 1 a 6 !  
        call    NLP_ok
        movlw   0
        xorwf   SWCERR,W
        btfsc   STATUS,Z
        goto    AEcontCAR
; NLP errato ,  perci invece del carattere "CAR" letto nella 
; EEPROM-dati del PIC  trasmetto 7 punti = errore !   OPPURE   
; "CAR" errato ,  perci trasmetto 7 punti = errore !  
AEsegnala:
; <  7 PUNTI + PAUSA LUNGA  >  
; per segnalare un errore verificatosi in fase di 
; scrittura e/o verifica della EEPROM-dati del PIC  
; oppure  per altri motivi .  
        call    SETTE_BIP
        call    LONGWAIT
        goto    AEincr

; Controllo formale di "CAR" .  
AEcontCAR:
        call    cont_CAR
        movlw   0
        xorwf   SWCERR,W
        btfss   STATUS,Z
; "CAR" errato ,  perci trasmetto 7 punti = errore !  
        goto    AEsegnala

; Ora dispongo di "CAR" e di NLP .  Converto 
; il carattere "CAR" in punti e/o linee .  
        call    CW_CAR
; Dopo il carattere "CAR"  vedo se  richiesta la PAUSA LUNGA .  
        btfsc   SALVA,7
        call    LONGWAIT
        goto    AEincr




; A questo punto devo convertire i bit 0 di "CAR" in un PUNTO e i 
; bit 1 di "CAR" in una LINEA .  Il valore di NLP indica quanti bit 
; di "CAR" debbo prendere in considerazione .  Sempre dal bit meno 
; significativo ( bit 0 ) al bit pi significativo ( bit 7 ) .  
; Gli NLP-bit di "CAR" possono essere al massimo sei ( 6 ) .  
;
CW_CAR:
        movf    NLP,W          ; W = NLP
        sublw   8              ; W = 8 - NLP
        movwf   RIM
CW_ripeti:
        bcf     STATUS,C
        rlf     CAR,F
        decfsz  RIM,F
        goto    CW_ripeti
; Ho spostato gli NLP-bit di "CAR" all'estrema sinistra del registro CAR .  
; Ossia da bit ... fino a bit 7 ,  inserendo tutti bit = 0 .  
        movf    NLP,W          ; W = NLP
        addlw   1              ; W = 1 + NLP
        movwf   RIM

; Sposto ogni bit nel CARRY e poi esamino se  = 0 oppure = 1 .  
CW_altro:
        rlf     CAR,F
        decfsz  RIM,F
        goto    CW_CARRY

;
; Attesa o pausa tra i caratteri .  
; --------------------------------  
; Pausa finale ( 3 volte la durata di un punto ) .  
; 120 = 3 * 40 .  Tre (3) volte la durata del punto .  
;
        movlw   120
        call    BREVEWAIT
        return

;
CW_CARRY:
        btfss   STATUS,C
        goto    CW_punto
; linea - + pausa 
        movf    WORK1,W
        movwf   DUR
        goto    CW_com
CW_punto:
; punto .  + pausa 
        movf    WORK2,W
        movwf   DUR
CW_com:
        call    LP1
        call    P_WAIT1
        goto    CW_altro





; Il bit n. 6 ( ossia il settimo bit )  usato come bit di riempimento 
; o  filler bit .  Est = 0  oppure  est = 1 ?  
calcola_NLP:
        btfsc   CAR,6
        goto    est_uno
;
; FILLER-BIT = ZERO  
; 000000000000000000000000000000000000000000000000000000000000000 
est_zero:
        btfsc   CAR,5
        goto    inizio_CAR5
        btfsc   CAR,4
        goto    inizio_CAR4
        btfsc   CAR,3
        goto    inizio_CAR3
        btfsc   CAR,2
        goto    inizio_CAR2
        btfsc   CAR,1
        goto    inizio_CAR1
        btfsc   CAR,0
        goto    inizio_CAR0
;
; Errore nel carattere "CAR" letto !  
sbaglio_NLP:
        clrf    NLP
        return
;
; FILLER-BIT = UNO  
; 111111111111111111111111111111111111111111111111111111111111111 
est_uno:
        btfss   CAR,5
        goto    inizio_CAR5
        btfss   CAR,4
        goto    inizio_CAR4
        btfss   CAR,3
        goto    inizio_CAR3
        btfss   CAR,2
        goto    inizio_CAR2
        btfss   CAR,1
        goto    inizio_CAR1
        btfss   CAR,0
        goto    inizio_CAR0
;
        goto    sbaglio_NLP
;
;
inizio_CAR5:
        call    azzera_67
        movlw   6
        goto    setta_NLP
;
inizio_CAR4:
        call    azzera_57
        movlw   5
        goto    setta_NLP
;
inizio_CAR3:
        call    azzera_47
        movlw   4
        goto    setta_NLP
;
inizio_CAR2:
        call    azzera_37
        movlw   3
        goto    setta_NLP
;
inizio_CAR1:
        call    azzera_27
        movlw   2
        goto    setta_NLP
;
inizio_CAR0:
        call    azzera_17
        movlw   1
setta_NLP:
        movwf   NLP
        return

;
azzera_17:
        bcf     CAR,1
azzera_27:
        bcf     CAR,2
azzera_37:
        bcf     CAR,3
azzera_47:
        bcf     CAR,4
azzera_57:
        bcf     CAR,5
azzera_67:
        bcf     CAR,6
        bcf     CAR,7
;
        return




; ***************************************  
; LETTURA  DELLA  EEPROM-dati  del  PIC .  
; ***************************************  
;
Leggi_EEPROM:
        movwf   EEADR
; Bank 1 .  
        bsf     STATUS,RP0
; Lettura della EEPROM-dati ( settando il flag RD ) .  
        bsf     EECON1,RD
; Bank 0 .  
        bcf     STATUS,RP0
        movf    EEDATA,W
        return




;
; Registri per la durata della LINEA e del PUNTO :  
; WORK1 per la LINEA  e  WORK2 per il PUNTO .  
; Pesatura o rapporto tra PUNTO e LINEA :  1 a 3 oppure 1 a 4 .  
; (  Linea  di  input  usata  nel  PIC  =  RB1 .  )  

PESATURA:
        movlw   40
        movwf   WORK2
; Interruttore per il rapporto linea-punto :  1 a 3 oppure 1 a 4 .  
; (  Linea  di  input  usata  nel  PIC  =  RB1 .  )  
        btfss   PORTB,PESO
        goto    UNO_TRE
; UNO_QUATTRO:  
; Rapporto impostato :  1 a 4 .  
        movlw   160
        movwf   WORK1
        return
;
UNO_TRE:
; Rapporto impostato :  1 a 3 .  
        movlw   120
        movwf   WORK1
        return




;
; Con questa routine  SALVA_MESSAGGIO  vengono memorizzati i MESSAGGI 
; personali ,  cio viene memorizzato nella EEPROM-dati del PIC il 
; contenuto della memoria volatile ,  tutti i registri buffers-xy .  
; ------------------------------------------------------------------------  
; Il programma non esegue nessuna codifica / decodifica del codice Morse ;  
; un  PUNTO viene memorizzato come  bit = 0  mentre  
; una LINEA viene memorizzata come  bit = 1 .  
; Tutti i punti ( bit 0 ) e tutte le linee ( bit 1 ) che compongono un 
; singolo carattere vengono inseriti nel registro "ICAR" usando 
; l'istruzione  rlf = Rotate Left File-register ... through Carry .  
; Leggere a questo proposito la ISR .  
; Ogni singolo carattere di un qualsiasi messaggio viene memorizzato 
; nel registro  "ICAR"  e poi copiato in un qualche registro BUF-xy .  
; Infine pu essere salvato nella EEPROM-dati del PIC .  
; Sequenza :  "ICAR"  -->  BUF-xy  -->  EEPROM-dati .  
;              fase   automatica   a richiesta  
; Notare che la fase < "ICAR" --> BUF-xy > avviene automaticamente 
; al completamento del carattere "ICAR" .  Invece la fase 
; < BUFFERS-xy --> EEPROM-dati > avviene solo su richiesta ,   
; cio premendo il pulsante SALVA BUFFERS .  
;
; ************************************  
; *  bit 0 = punto ,  bit 1 = linea  *  
; ************************************  
;
; ESEMPI :     CAR            NLP  
;
;            00000000          2 = bit 1 e  bit 0 di "CAR"  
;                  .. = I  
;
;            00000101          3 = bit 2 ,  bit 1 e  bit 0 di "CAR"  
;                 -.- = K  
;
;            00001001          4 = bit 3 ,  bit 2 ,  bit 1  e  bit 0 di CAR  
;                -..- = X  
;
; In questo programma ( ALFAPIC.ASM ) ho usato un nuovo metodo per 
; memorizzare i caratteri CW .  In poche parole sono riuscito a usare un 
; singolo byte per ogni CARattere CW !  
; Vediamo come esaminando la mappa del byte "CAR" :  
;
; bit n. 7 6 5 4 3 2 1 0  <=== numerazione assembly dei bit  
;        0 0 0 0 0 0 0 0  <=== bit di "CAR"  
;        8 7 6 5 4 3 2 1  <=== numerazione "normale" dei bit  
;
; L'ottavo bit ( cio il bit n. 7 ) quando  impostato a 1 
; indica PAUSA LUNGA dopo il carattere ,  cio dopo la parola .  
;
; Il settimo bit ( cio il bit n. 6 )  il bit di riempimento :  
; esso indica quando iniziano i bit del carattere "CAR" !  
; Possiamo definirlo bit di filler cio di riempimento .  Esempi :  
; 10000101 = pausa lunga dopo il carattere K = 101 linea punto linea ;  
; 01111101 = nessuna pausa dopo il carattere A = 01 punto linea ;  
; 11111101 = pausa   lunga dopo il carattere A = 01 punto linea ;  
; 11100000 = pausa lunga dopo il carattere 5 = 00000 5 punti .  
;
; Quindi ,  se il primo bit di "CAR"  un punto cio 0 ,  il 
; filler-bit sar 1 ,  mentre se il primo bit di CAR  una linea 
; cio 1 ,  il filler-bit sar 0 .  E non solo il filler-bit ,  ma 
; anche tutti i bit successivi al filler-bit andando verso destra ( cio 
; verso il bit n. 0 ) fino al primo bit di "CAR" escluso .  
; In questo modo sono riuscito ad inserire tre informazioni nel byte :  
; 1) carattere CW "CAR" con bit 0 = punto e bit 1 = linea ;  
; 2) sua lunghezza in bit ( grazie al "trucco" del filler-bit )  e  infine 
; 3) indicazione dell'eventuale pausa lunga dopo il carattere .  
;

SALVA_MESSAGGIO:
; Disabilito TUTTI gli interrupts !  
        bcf     INTCON,GIE

; Accendo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
; LED rosso acceso = STOP per altre eventuali operazioni !  
;
        bcf     PORTA,LEDR
; Proseguo solo quando rilascio il pulsante SALVA BUFFERS ( SAVEBUF ) .  
        btfss   PORTB,SAVEBUF
        goto    SALVA_MESSAGGIO
; In questo modo ho il tempo per chiudere il contatto dei PUNTI ,  
; nel caso volessi duplicare o ripetere il salvataggio dei BUFers-xy 
; nella EEPROM-dati del PIC .  

; Paletta del PUNTO del tasto in uso ?  
; Linea RB4 = PUNTO ?  
        btfsc   PORTB,PUNTO
        goto    SMtest
        bcf     GENREG,4

; Controllo il bit numero 4 di GENREG :  
; se = 1 NON salvo la memoria volatile nella EEPROM-dati del PIC ;  
; se = 0 salvo i BUFfers-xy nella EEPROM-dati del PIC .  
; Memoria volatile = BUFfers-xy .  
; GENREG,4 = 1  NO SALVA_MESSAGGIO nella EEPROM-dati del PIC ;  
; GENREG,4 = 0  s ,  SALVA_MESSAGGIO nella EEPROM-dati del PIC .  
; Questo bit viene azzerato ovviamente alla partenza e anche ogni 
; volta che memorizzo un nuovo CARattere CW ( vedere la routine 
; dell'interrupt punto-linea ,  linee RB4-RB5 ) .  
;
SMtest:
        btfsc   GENREG,4
        goto    SMfine

; Nel byte n. 0 ( il primo ) il byte di partenza per la memorizzazione .  
; Viene infatti usato da ALFAPIC come indirizzo dell'ultimo byte occupato 
; nella EEPROM-dati del PIC .  
        movlw   0
        call    Leggi_EEPROM
        movwf   TOTC

; Verifico che 1 <= TOTC <= 63 !   In caso negativo azzero TOTC .  
        call    TOTC_ok
        movlw   0
        xorwf   SWCERR,W
        btfss   STATUS,Z
        clrf    TOTC

; Copio BUF1 !  
        movf    BUF1,W
        movwf   CAR
        call    COPIABUF

; Copio BUF2 !  
        movf    BUF2,W
        movwf   CAR
        call    COPIABUF

; Copio BUF3 !  
        movf    BUF3,W
        movwf   CAR
        call    COPIABUF

; Copio BUF4 !  
        movf    BUF4,W
        movwf   CAR
        call    COPIABUF

; Copio BUF5 !  
        movf    BUF5,W
        movwf   CAR
        call    COPIABUF

; Copio BUF6 !  
        movf    BUF6,W
        movwf   CAR
        call    COPIABUF

; Copio BUF7 !  
        movf    BUF7,W
        movwf   CAR
        call    COPIABUF

; Copio BUF8 !  
        movf    BUF8,W
        movwf   CAR
        call    COPIABUF

; Copio BUF9 !  
        movf    BUF9,W
        movwf   CAR
        call    COPIABUF

; Copio BUF10 !  
        movf    BUF10,W
        movwf   CAR
        call    COPIABUF

; Ultima operazione :  memorizzo / salvo nel BYTE ZERO  
; della EEPROM-dati del PIC  il valore finale di TOTC .  
; Copio il valore finale di TOTC in "CAR" ,  poi azzero TOTC .  
        movf    TOTC,W
        movwf   CAR
        clrf    TOTC
        call    scriviEEPROM
; Accendo il bit numero 4 di GENREG = non salvare pi i BUFfers-xy 
; nella EEPROM-dati del PIC se prima non viene azzerato questo bit !  
; Cio disattivo la ripetizione del salvataggio ,  della copia dei 
; BUFFERS-xy nella EEPROM-dati del PIC .  
        bsf     GENREG,4

; ------------------------------------------------    
; USCITA DA QUESTA ROUTINE  < SALVA_MESSAGGIO >  !    
; ------------------------------------------------    
SMfine:
; Spengo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
        bsf     PORTA,LEDR
        return




;
COPIABUF:
; Se "CAR" = 0  allora esco subito da questa routine .  
        movlw   0
        xorwf   CAR,W
        btfsc   STATUS,Z
        return

; Incremento il valore di TOTC .  
        incf    TOTC,F
; TOTC = 64 ?  
        movlw   64
        xorwf   TOTC,W
        btfss   STATUS,Z
        goto    CBEEPROM
        movlw   1
        movwf   TOTC
        
CBEEPROM:
; Memorizzazione di un carattere "CAR" del MESSAGGIO .  
        call    scriviEEPROM
        return




; --------------------------------------------------------------------  
; La routine filler_bit viene chiamata solo dalla routine SALVA_ICAR .  
; --------------------------------------------------------------------  
;
; Effetto di questa routine :  
; Se "ICAR" = A = 00000001 ( INLP = 2 )  all'uscita  diventato 01111101 .  
; Se "ICAR" = K = 00000101 ( INLP = 3 )  all'uscita  rimasto   00000101 .  
; Nel primo caso il filler-bit ( bit n. 6 ossia il settimo bit ) 
; vale 1 mentre nel secondo vale 0 .  
;
filler_bit:
; INLP = 1 ?  
        movlw   1
        xorwf   INLP,W
        btfsc   STATUS,Z
        goto    NLP_uno
; INLP = 2 ?  
        movlw   2
        xorwf   INLP,W
        btfsc   STATUS,Z
        goto    NLP_due
; INLP = 3 ?  
        movlw   3
        xorwf   INLP,W
        btfsc   STATUS,Z
        goto    NLP_tre
; INLP = 4 ?  
        movlw   4
        xorwf   INLP,W
        btfsc   STATUS,Z
        goto    NLP_quattro
; INLP = 5 ?  
        movlw   5
        xorwf   INLP,W
        btfsc   STATUS,Z
        goto    NLP_cinque
;
; Se arrivo qui allora INLP = 6 .  
;
; INLP = 6 !  
        btfss   ICAR,5
        goto    da_6
        return
;
NLP_uno:
        btfss   ICAR,0
        goto    da_1
        return
NLP_due:
        btfss   ICAR,1
        goto    da_2
        return
NLP_tre:
        btfss   ICAR,2
        goto    da_3
        return
NLP_quattro:
        btfss   ICAR,3
        goto    da_4
        return
NLP_cinque:
        btfss   ICAR,4
        goto    da_5
        return
da_1:
        bsf     ICAR,1
da_2:
        bsf     ICAR,2   
da_3:
        bsf     ICAR,3
da_4:
        bsf     ICAR,4
da_5:
        bsf     ICAR,5
da_6:
        bsf     ICAR,6
; Non imposto il bit-7 poich viene gestito nella routine 
; dell'interrupt punto-linea .  
        return




; ********************************************  
; Controllo formale del carattere CW immesso .  
; ********************************************  
;
; ROUTINE AGGIORNATA !  Ammesse ora anche le seguenti 
; lettere accentate :   ,   ,    e   .  
;
;        CODIFICA di 
; CAR      MSGCW     BINARIO     DECIMALE 
;  E  .       0      00000000        0 
;  T  -       1      00000001        1 
;
;  I  ..      00     00000000        0 
;  A  .-      01     00000001        1 
;  N  -.      10     00000010        2 
;  M  --      11     00000011        3 
;
;  S  ...     000    00000000        0 
;  U  ..-     001    00000001        1 
;  W  .--     011    00000011        3 
;  D  -..     100    00000100        4 
;  K  -.-     101    00000101        5 
;  G  --.     110    00000110        6 
;  R  .-.     010    00000010        2 
;  O  ---     111    00000111        7 
;
;  H  ....    0000   00000000        0 
;  B  -...    1000   00001000        8 
;  C  -.-.    1010   00001010       10 
;  F  ..-.    0010   00000010        2 
;  J  .---    0111   00000111        7 
;  L  .-..    0100   00000100        4 
;  P  .--.    0110   00000110        6 
;  Q  --.-    1101   00001101       13 
;  V  ...-    0001   00000001        1 
;  X  -..-    1001   00001001        9 
;  Y  -.--    1011   00001011       11 
;  Z  --..    1100   00001100       12 
;
;    ..--    0011   00000011        3 
;    ---.    1110   00001110       14 
;
;    ..-..   00100  00000100        4 
;    .--.-   01101  00001101       13 
;
;  1  .----   01111  00001111       15 
;  2  ..---   00111  00000111        7 
;  3  ...--   00011  00000011        3 
;  4  ....-   00001  00000001        1 
;  5  .....   00000  00000000        0 
;  6  -....   10000  00010000       16 
;  7  --...   11000  00011000       24 
;  8  ---..   11100  00011100       28 
;  9  ----.   11110  00011110       30 
;  0  -----   11111  00011111       31 
;
;  .  .-.-.-  010101 00010101       21      punto 
;  ,  --..--  110011 00110011       51      virgola 
;  ?  ..--..  001100 00001100       12      punto interrogativo 
;  :  ---...  111000 00111000       56      due punti 
;  ;  -.-.-.  101010 00101010       42      punto e virgola 
;  -  -....-  100001 00100001       33      trattino o lineetta 
;  '  .----.  011110 00011110       30      apice 
;  /  -..-.   10010  00010010       18      barra 
;  (  -.--.   10110  00010110       22      parentesi tonda aperta 
;  )  -.--.-  101101 00101101       45      parentesi tonda chiusa 
;  "  .-..-.  010010 00010010       18      doppio apice 
;
;  =  -...-   10001  00010001       17      lineette o segno di uguale 
;  AR .-.-.   01010  00001010       10      fine del messaggio 
;  AS .-...   01000  00001000        8      aspetta 
;  KA -.-.-   10101  00010101       21      attenzione 
;  KN -.--.   10110  00010110       22      passo alla sola stazione in QSO 
;  SK ...-.-  000101 00000101        5      fine del QSO 
;
;  errore 
;     ......  000000 00000000        0      errore ( 6 punti ) 
;
;
; RIEPILOGO IN DECIMALE DEI VALORI POSSIBILI :  
;  0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 - - 21 22 - 24 - - - 
;  28 - 30 31 - 33 - - - - - - - - 42 - - 45 - - - - - 51 - - - - 56 
;  ( il trattino indica valori mancanti ) .  
;
; BINARIO     DECIMALE  
; 76543210 numero del bit 
; 00000000        0 
; 00000001        1 
; 00000010        2 
; 00000011        3 
; 00000100        4 
; 00000101        5 
; 00000110        6 
; 00000111        7 
; 00001000        8 
; 00001001        9 
; 00001010       10 
; 00001011       11 
; 00001100       12 
; 00001101       13 
; 00001110       14 
; 00001111       15 
; 00010000       16 
; 00010001       17 
; 00010010       18 
; -----------------   19 20 
; 00010101       21 
; 00010110       22 
; -----------------   23 
; 00011000       24 
; -----------------   25 26 27 
; 00011100       28 
; -----------------   29 
; 00011110       30 
; 00011111       31 
; -----------------   32 
; 00100001       33 
; -----------------   34 35 36 37 38 39 40 41 
; 00101010       42 
; -----------------   43 44 
; 00101101       45 
; -----------------   46 47 48 49 50 
; 00110011       51 
; -----------------   52 53 54 55 
; 00111000       56 
;
; --bit---  
; 76543210  

cont_CAR:
        btfsc   CAR,7
        goto    no_buono
        btfsc   CAR,6
        goto    no_buono
;
        btfsc   CAR,5
        goto    cont_ancora
        btfsc   CAR,4
        goto    cont_ancora
; Valore inferiore a 16 .  
        goto    si_buono
;
cont_ancora:
; CAR = 16  ?  
        movlw   16
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 17  ?  
        movlw   17
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 18  ?  
        movlw   18
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 21  ?  
        movlw   21
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 22  ?  
        movlw   22
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 24  ?  
        movlw   24
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 28  ?  
        movlw   28
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 30  ?  
        movlw   30
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 31  ?  
        movlw   31
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 33  ?  
        movlw   33
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 42  ?  
        movlw   42
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 45  ?  
        movlw   45
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 51  ?  
        movlw   51
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
; CAR = 56  ?  
        movlw   56
        xorwf   CAR,W
        btfsc   STATUS,Z
        goto    si_buono
;
        goto    no_buono

; CAR ok !!!  
si_buono:
        clrf    SWCERR
        return

; CAR errato !!!  
no_buono:
        movlw   11111111B
        movwf   SWCERR
        return




; *****************************************  
; SCRITTURA  della  EEPROM-dati  del  PIC .  
; *****************************************  
;
scriviEEPROM:
;
; Bytes della EEPROM-dati del PIC :  MAPPA GENERALE .  
;
;    MESSAGGIO :  
;
; 0 1-----------------------------63   =  64  byte  utilizzati  
;                "CAR"  
;
; 0  1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 ................ 58 59 60 61 62 63 
;    <---  MESSAGGIO  MESSAGGIO  MESSAGGIO  MESSAGGIO  MESSAGGIO   --->  
;                                                                         
; > Nel byte 0 scrivo TOTC = indirizzo dell'ultimo byte occupato ,  
;        quindi ,  incrementando di 1 ,  indirizzo di partenza per 
;        successivi salvataggi dei registri BUFfers-xy nella EEPROM-dati .  
;                                                                         
; Nel registro EEADR l'indirizzo della locazione di EEPROM nel 
; quale intendiamo salvare il carattere "CAR" .  

        movf    TOTC,W
        movwf   EEADR

; Nel registro EEDATA il valore che intendiamo inviare alla locazione di 
; EEPROM-dati del PIC indirizzata con il registro EEADR .  
        movf    CAR,W
        movwf   EEDATA
        call    write_EEPROM
; Aspetto che l'operazione sia completata .  
scrivi_LOOP:
        btfsc   EECON1,WR
        goto    scrivi_LOOP
; Sono ancora sul banco 1 :  azzero WREN .  
        bcf     EECON1,WREN
; Controllo il bit-flag WRERR .  
        btfss   EECON1,WRERR
        goto    verifica_CAR
;
        bcf     STATUS,RP0
; <  7 PUNTI + PAUSA LUNGA  >  
; per segnalare un errore verificatosi in fase di 
; scrittura e/o verifica della EEPROM-dati del PIC .  
        call    SETTE_BIP
        goto    scriviEEPROM

; VERIFICO LA CORRETTEZZA DELLA SCRITTURA nella EEPROM-dati .  
verifica_CAR:
        call    VERIFICA_SCRITTURA
        movlw   0
        xorwf   SWCERR,W
        btfss   STATUS,Z
        goto    scriviEEPROM

; Bank 0 .  
        bcf     STATUS,RP0
        return




; *******************************************************  
; ROUTINE per la SCRITTURA di UN BYTE nella EEPROM-dati .  
; *******************************************************  

write_EEPROM:
; Bank 1 .  
        bsf     STATUS,RP0
; Disabilito eventuali interrupts .  
        bcf     INTCON,GIE
; Azzero il flag Write Error Flag bit .
        bcf     EECON1,WRERR
; Abilita la scrittura mediante il flag WREN di EECON1 .
        bsf     EECON1,WREN
; Codice di accesso alla EEPROM .  
        movlw   H'55'
        movwf   EECON2
        movlw   H'AA'
        movwf   EECON2
; Inizio/Avvio della scrittura vera e propria .  
        bsf     EECON1,WR
        return




; **********************************************************  
; VERIFICA  della  SCRITTURA  nella  EEPROM-dati  del  PIC .  
; **********************************************************  
;
VERIFICA_SCRITTURA:
; SWCERR = 0 decimale = nessun errore !  
; SWCERR = 11111111 binario = 255 decimale = errore di scrittura .  
        clrf    SWCERR
;
        bcf     STATUS,RP0        ; Bank 0 !
        movf    EEDATA,W          ; W = EEDATA originale
        bsf     STATUS,RP0        ; Bank 1 !
        bsf     EECON1,RD         ; Lettura del valore scritto
        bcf     STATUS,RP0        ; Bank 0 !
; Il valore originale scritto in W  uguale al valore letto in EEDATA ?  
        subwf   EEDATA,W          ; W = EEDATA letto - W(= EEDATA originale)
        btfss   STATUS,Z          ; differenza = 0 ?
; Errore di scrittura .  
        goto    VS_errore
;
; Scrittura ok !  
        return
;
; Errore in fase di scrittura della EEPROM-dati del PIC .  
VS_errore:
        movlw   11111111B
        movwf   SWCERR
; <  7 PUNTI + PAUSA LUNGA  >  per segnalare  
; errore nella verifica della EEPROM-dati .  
        call    SETTE_BIP
        call    LONGWAIT
        return




; ***********************************************************  
; ROUTINE per l'AZZERAMENTO di tutta la EEPROM-dati del PIC .  
; ***********************************************************  

azzeraEEPROM:
; Bank 0 .  
        bcf     STATUS,RP0
; Accendo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
; LED rosso acceso = STOP per altre eventuali operazioni !  
;
        bcf     PORTA,LEDR
        clrf    fisicoT
;
azzeraBYTE:
        movlw   64
        xorwf   fisicoT,W
        btfss   STATUS,Z
        goto    aEscrivi
; Quando fisicoT = 64 la cancellazione  terminata .  
; Spengo il LED rosso di STOP .  LED -- LED -- LED -- LED -- LED --  
; USCITA DALLA ROUTINE  azzeraEEPROM .  
        bsf     PORTA,LEDR
        return

; Nel registro EEADR l'indirizzo della locazione di EEPROM-dati del PIC 
; che intendiamo azzerare .  In pratica tutte le 64 locazioni della 
; EEPROM-dati del PIC :  da 0 a 63 !  
;
aEscrivi:
        movf    fisicoT,W
        movwf   EEADR
; Nel registro EEDATA il valore che intendiamo inviare alla locazione di 
; EEPROM-dati indirizzata con il registro EEADR .  
; Poich voglio azzerare tutto il contenuto della EEPROM-dati ,  
; il valore da scrivere in ogni byte della EEPROM  sempre zero-0 .  
        movlw   00000000B
        movwf   EEDATA
        call    write_EEPROM
; Aspetto che l'operazione sia completata .  
aELOOP:
        btfsc   EECON1,WR
        goto    aELOOP
; Sono ancora sul banco 1 :  azzero WREN .  
        bcf     EECON1,WREN
; Controllo il bit-flag WRERR = WRite ERRor .  
        btfss   EECON1,WRERR
        goto    aECAR
; Errore nella scrittura del byte di EEPROM-dati .  
        bcf     STATUS,RP0
; <  7 PUNTI + PAUSA LUNGA  >  
; per segnalare un errore verificatosi in fase di 
; scrittura e/o verifica della EEPROM-dati del PIC  
; oppure  per altri motivi .  
        call    SETTE_BIP
        call    LONGWAIT
        goto    aEscrivi

;
;
aECAR:
; VERIFICO LA CORRETTEZZA DELLA SCRITTURA ,  cio dell'azzeramento 
; del byte della EEPROM-dati del PIC .  
        call    VERIFICA_SCRITTURA
        movlw   0
        xorwf   SWCERR,W
        btfss   STATUS,Z
        goto    aEscrivi

; Bank 0 .  
        bcf     STATUS,RP0
        incf    fisicoT,F
        goto    azzeraBYTE





; ----------------------------------------------------------------------  
; La routine TOTC_ok viene chiamata solo dalla routine SALVA_MESSAGGIO .  
; ----------------------------------------------------------------------  
;
; TOTC deve essere compreso fra 1 e 63 ,  estremi compresi .  
; 1 <--- TOTC ---> 63   ossia   1 <= TOTC <= 63 .  
;
; BINARIO     DECIMALE  
; 76543210 <--- numero del bit  
; 00000000        0    00000001        1 
; 00000010        2    00000011        3 
; 00000100        4    00000101        5 
; 00000110        6    00000111        7 
; 00001000        8    00001001        9 
; 00001010       10    00001011       11 
; 00001100       12    00001101       13 
; 00001110       14    00001111       15 
; 00001010       10    00001011       11 
; 00001100       12    00001101       13 
; 00001110       14    00001111       15 
; 00010000       16    00010001       17 
; 00010010       18    00010011       19 
; 00010100       20    00010101       21 
; 00010110       22    00010111       23 
; 00011000       24    00011001       25 
; 00011010       26    00011011       27 
; 00011100       28    00011101       29 
; 00011110       30    00011111       31 
; 00100000       32    00100001       33 
; ........             ........          
; 00111110       62    00111111       63

TOTC_ok:
        btfsc   TOTC,7
        goto    no_ok
        btfsc   TOTC,6
        goto    no_ok

; TOTC ok !  
        clrf    SWCERR
        return

; TOTC errato !!!  
no_ok:
        movlw   11111111B
        movwf   SWCERR
        return




;
; NLP deve essere compreso fra 1 e 6 ,  estremi compresi .  
; 1 <--- NLP ---> 6 
;
NLP_ok:
; NLP = 0  ?   
        movlw   00000000B
        xorwf   NLP,W
        btfsc   STATUS,Z
        goto    errore_NLP
;
; BINARIO     DECIMALE  
; 76543210 numero del bit 
; 00000000        0 
; 00000001        1 
; 00000010        2 
; 00000011        3 
; 00000100        4 
; 00000101        5 
; 00000110        6 
; 00000111        7 
; 00001000        8 
; 00001001        9 
        btfsc   NLP,7
        goto    errore_NLP
        btfsc   NLP,6
        goto    errore_NLP
        btfsc   NLP,5
        goto    errore_NLP
        btfsc   NLP,4
        goto    errore_NLP
        btfsc   NLP,3
        goto    errore_NLP
; NLP = 7  ?   
        movlw   7
        xorwf   NLP,W
        btfsc   STATUS,Z
        goto    errore_NLP

; NLP ok !  
        clrf    SWCERR
        return

; NLP errato !!!  
errore_NLP:
        movlw   11111111B
        movwf   SWCERR
        return




;
; AZZERAMENTO dei registri CTRPL e SWCULT .  
azzeraPL:
        clrf    CTRPL
        clrf    SWCULT
        return




;
; AZZERAMENTO dei registri CAR e NLP .  
azzeraCAR:
        clrf    CAR
        clrf    NLP
        return



;
; AZZERAMENTO dei registri "ICAR" e INLP gestiti nella ISR .  
resetICAR:
        clrf    ICAR
        clrf    INLP
        return




;
; ISTRUZIONI ANTI-RIMBALZO !  
; Valori provati per gestire il rimbalzo del contatto Punto / Linea .  
;
; Con OSCILLATORE esterno RC ( versione di ALFAPIC non divulgata ) .  
; 255 decimale = 11111111 binario .  Troppo alto con oscillatore RC .  
; 127 decimale =  1111111 binario .  Accettabile con oscillatore RC .  
;  63 decimale =   111111 binario .  ACCETTABILE con oscillatore RC .  
;  31 decimale =    11111 binario .  Poco con oscillatore esterno RC .  
;
; Con OSCILLATORE XTAL ( a quarzo ) .  
; 255 decimale = 11111111 binario .  
; 127 decimale =  1111111 binario .  
;  31 decimale =    11111 binario .  Poco con XTAL a 4,194304 MHz .  
;

RITARDO:
        clrf    ANTIRS
RDecr:
        nop
; ANTIRS = ANTIRS - 1 .  
        decfsz  ANTIRS,F
        goto    RDecr
        return




;
; Imposto qui i valori iniziali dei registri WT1 e WT2 che verranno 
; poi decrementati nel Main_Loop .  In pratica ,  ogni volta che 
; immetto un Punto o una Linea ,  riparto con il conteggio  
; della pausa dai valori iniziali .  Anche quando completo un CARattere .  
;
; Con oscillatore esterno RC gestisco un solo registro :  WTEMPO .  
; Il valore 255 decimale = 11111111 binario  troppo alto :  
; il fine CARattere avviene dopo oltre 1 secondo ( quasi due ) .  
; Il valore 127 decimale =  1111111 binario comporta una pausa 
; di circa 0,5 secondi ,  accettabile ma forse ancora troppo lunga .    
; DEFAULT ALL'ACCENSIONE DEL PIC :  
; il valore  63 decimale =   111111 binario riduce ulteriormente la pausa  
; gestita con il registro WTEMPO .  Accettabile .  DEFAULT .  
; Il valore  31 decimale =    11111 binario riduce ancor di pi la pausa .  
;
; Con un oscillatore esterno XTAL a quarzo da 4,194304 MHz 
; debbo gestire due ( 2 ) registri :  WT1 e WT2 !  
; Un unico registro ,  anche impostato a 255 decimale = 11111111 binario ,  
; non basta .  
;

SETTAWT:
; Azzero WT1 ( oppure potrei impostarlo anche a 255 decimale ) .  
        clrf    WT1
; Imposto WT2 a 15 decimale .  
        movlw   15
        movwf   WT2
; Se l'ascolto  disattivato ,  debbo impostare un valore 
; pi alto per il registro WT2 .  
        btfss   PORTA,ASCEE
        return
; Imposto WT2 a 50 decimale .  
        movlw   50
        movwf   WT2
        return


;
; Attivando l'interrupt del timer ( registro TMR0 ) basta un solo 
; registro ,  per esempio WT2 ,  per ottenere i seguenti tempi :  
;
;  Ŀ 
;   WT2    secondi    
;  Ĵ 
;    18    1,125      
;    17    1,0625     
;    16    1          
;    15    0,9375     
;    14    0,875      
;    13    0,8125     
;    12    0,75       
;    11    0,6875     
;    10    0,625      
;     9    0,5625     
;     8    0,5        
;     7    0,4375     
;     6    0,375      
;     5    0,3125     
;     4    0,25       
;     3    0,1875     
;     2    0,125      
;     1    0,0625     
;   
;
; bit7  bit6  bit5  bit4  bit3 bit2  bit1  bit0 -  registro TMR0  
;   16    32    64   128   256  512  1024  2048 -  frequenza in Hz  
;
; Purtroppo per ,  i sedici ( 16 ) interrupts al secondo del timer ,  
; "disturbano" la nota di Bassa Frequenza in altoparlante .  
; E anche se ascoltando con un cicalino ( buzzer ) il problema non si 
; manifesta pi di tanto ,  visto che  possibile gestire il tutto 
; via software ,  Pierluigi IW4AA ,  dopo alcune prove ,  ha preferito 
; rinunciare all'interrupt di TMR0 e implementare via software la pausa 
; per la fine di un carattere e anche il ritardo  " anti-rimbalzo " .  
;




;
; Cancellazione / azzeramento della memoria volatile ,  cio dei 
; registri BUFfers-xy  e  anche di alcuni altri registri .  
;
azzeraBUF:
; Azzero i registri BUFfers-xy ,  memoria volatile per i CARatteri CW  
; ( punti e linee ) quando sono in modalit MEMORIA .  
        clrf    BUF1
        clrf    BUF2
        clrf    BUF3
        clrf    BUF4
        clrf    BUF5
        clrf    BUF6
        clrf    BUF7
        clrf    BUF8
        clrf    BUF9
        clrf    BUF10
        clrf    BUFA
        clrf    BUFB
;
        clrf    CTRCW
        clrf    PNTRIP
        clrf    SCAR
        clrf    SNLP
;
        return




; Un veloce  "bip"  ripetuto 7 volte per segnalare un errore .  
; 7 punti =  .......  .  
; Sequenza :  
; PUNTO pausa PUNTO pausa PUNTO pausa PUNTO pausa PUNTO pausa PUNTO pausa PUNTO pausa  
;   1           2           3           4           5           6           7  
SETTE_BIP:
        movlw   7
        movwf   RIM
SB_DECR:
; punto .  + pausa  
        movf    WORK2,W
        movwf   DUR
        call    LP1
        call    P_WAIT1
;
        decfsz  RIM,F
        goto    SB_DECR
; Pausa finale .  
        movlw   120
        movwf   DUR
        call    PW1
        return




;
; Emissione della nota di CW :  PUNTI o LINEE .  
;
; Bisogna usare il bit-0 o il bit-1 o il bit-2 del registro TMR0 .  
;
; DIVISIONI EFFETTUATE DA ALFAPIC :  
;
; quarzo XTAL = 4,194304 MHz = 4.194.304 Hz 
; 4.194.304 / 4   = 1.048.576 Hz  hardware del PIC 
; 1.048.576 / 256 = 4.096 Hz      PRESCALER del PIC 
; 4096 / 256      = 16 Hz         TIMER0 ( registro TMR0 ) 
; 16 / 16         = 1 Hz          eventuale contatore per i secondi 
;
; bit-7  bit-6  bit-5  bit-4  bit-3 bit-2  bit-1  bit-0 -  registro TMR0  
;    16     32     64    128    256   512   1024   2048 -  frequenza in Hz  
;

LP1:

;
; Interruttore  < out BF / out ON-OFF > .  
        btfss   PORTA,ONOFF
        goto    OUT_ONOFF

; Uscita di BF a onda quadra per altoparlanti .  
OUT_BF:
        btfss   TMR0,1
        goto    OUT_BF
        bcf     PORTA,BF1
LIN10:
        btfsc   TMR0,1
        goto    LIN10
        bsf     PORTA,BF1
        decfsz  DUR,F
        goto    OUT_BF
        bsf     PORTA,BF1
        return

; Uscita di tipo ON/OFF per cicalini o buzzer e TX .  
OUT_ONOFF:
        btfss   TMR0,1
        goto    OUT_ONOFF
        bcf     PORTA,BF1
LIN20:
        btfsc   TMR0,1
        goto    LIN20
        bcf     PORTA,BF1
        decfsz  DUR,F
        goto    OUT_ONOFF
        bsf     PORTA,BF1
        return




;
P_WAIT1:
; Durata della pausa = WORK2 = stessa durata del PUNTO .  
        movf    WORK2,W
        movwf   DUR
PW1:
        btfss   TMR0,1
        goto    PW1
        bsf     PORTA,BF1
PAU10:
        btfsc   TMR0,1
        goto    PAU10
        bsf     PORTA,BF1
        decfsz  DUR,F
        goto    PW1
        return



; ********************  
; FINE DEL PROGRAMMA .  
; ********************  

        END
